////////////////////////////////////////////////////////////////////////////
class Console : public ROTI
{
public:
HMODULE hMODULE;
unsigned int ID;
char *NAME;
unsigned int active;
MSG *cMSG;
Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
Console(HMODULE hMOD,char *n,unsigned int id);
Console(char *n);
void initialize(HMODULE hMOD,char *n,unsigned int id);
virtual void start();
virtual void stop();
virtual void AddComponent(HMODULE hMOD,char *text,
		  unsigned int id);
void AddComponent_primus(unsigned int id);
void add_before_Component(unsigned int id,unsigned int o);
void add_after_Component(unsigned int id,unsigned int o);
virtual void Respond(MSG *Msg);
virtual void Reflex();
~Console();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//Console::Console(char *n,unsigned int id):ROTI()
//{
//ID=id;
// NAME=new char [strlen(n)];
// strcpy(NAME,n);
//responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Console,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Console,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
//active=0;
//};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console::Console(HMODULE hMOD,char *n,unsigned int id):ROTI()
{
hMODULE=NULL;
ID=NULL;
NAME=NULL;
MSG_Q=NULL;
cMSG=NULL;
reflexor=NULL;
responder=NULL;
iStart=NULL;
iStop=NULL;
initialize(hMOD,n,id);
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::initialize(HMODULE hMOD,char *n,unsigned int id)
{
hMODULE=hMOD;
 ID=id;
 NAME=new char [strlen(n)];
 cMSG=new MSG();
 strcpy(NAME,n);
responder=new Coordinator();
reflexor=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Console,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Console,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
active=0;
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void Console::start()
{
Component *j;
if(active==0)
{
for(j=(Component *)PRIMUS;
	    j;
	    j=++(*j))
 {
 };

//responder->Activate(iStop);
//responder->Deactivate(iStart);
active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void Console::stop()
{
if(active==1)
{
//responder->Deactivate(iStop);
//responder->Activate(iStart);

 active=0;
};
}
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
void Console::AddComponent(HMODULE hMOD,char *text,
		   unsigned int id)
{
 Component *i;
 i=new Component(hMOD,text,id);
 PUT_MAXIMUS((NEXUS *)i);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::Respond(MSG *Msg)
{
Component *x;
cMSG->copy(Msg);
responder->Respond(cMSG,this);
for(x = (Component *)PRIMUS;
    x;
    x = ++(*x)) x->Respond(cMSG);

};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void Console::Reflex()
{
Component *x;
reflexor->Reflex(this);
for(x=(Component *)PRIMUS;
    x;
    x=++(*x))x->Reflex();
};
/////////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
void Console::add_before_Component(unsigned int id,unsigned int o)
{
 Component *i,*j;
 i=new Component(id);
 for(j=(Component *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::add_after_Component(unsigned int id,unsigned int o)
{
 Component *i,*j;
 i=new Component(id);
 for(j=(Component *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console::~Console()
{
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);

if(responder)delete responder;
if(reflexor)delete reflexor;
    if(cMSG)delete cMSG;
//if(background!=NULL)delete (background);
if(NAME)delete (NAME);
if(PRIMUS)
 {
  Component* NEXT;
  Component* current = (Component *)PRIMUS;
  for(;;)
     {
      NEXT=(Component *)current->next;
      if(current)delete current;
      if(!NEXT)break;
      current=NEXT;
     };
  };
};
////////////////////////////////////////////////////////////////////////////
