//////////////////////////////////////////////////////////////////////
//INCLUDES and DEFINES////////////////////////////////////////////////
//#include<conio.h>
#include <stdio.h>
#include <stdlib.h>
//#include <bios.h>
//#include <dos.h>
//#include <alloc.h>
#include <string.h>
//#include<iostream.h>

#include "c:\programs\osos\geometry\point.h"
#include "c:\programs\osos\geometry\rect.h"

#include "c:\programs\osos\core\xstring.h"
#include "c:\programs\osos\core\objects.h"
#include "c:\programs\osos\core\message.h"

#include "c:\programs\osos\nexus\nexus.h"
#include "c:\programs\osos\nexus\impulse.h"

#include "c:\programs\osos\core\msgqueue.h"
#include "c:\programs\osos\core\componen.h"
#include "c:\programs\osos\core\console.h"
#include "c:\programs\osos\core\module.h"
#include "c:\programs\osos\core\modulatr.h"

#include <allegro.h>

#include "c:\programs\osos\devices\keyboard\keyboard.h"

#include "c:\programs\osos\devices\mouse\mouse.h"





#include "c:\programs\osos\devices\display\grafix.h"

#include "c:\programs\osos\gxi\mousetrp.h"
#include "c:\programs\osos\gxi\pushbtn\pbutton.h" 

#include "c:\programs\osos\gxi\coaster.h"
#include "c:\programs\osos\gxi\palcons.h"

#define stConstruct 0
#define stReflex 1
#define stRespond 2
#define stDestruct 3
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
//VARIABLES///////////////////////////////////////////////////////

int done;
int status;
int pressed,oldx,oldy;
int GLOBALX,GLOBALY;
int CURSORX,CURSORY;
int reflextoggle;
int respondtoggle;
Modulator *DEVICE_MODULATOR;
//PushButton *MT;
PaletteModule *PM;
PaletteConsole *PC;
MSG *currentMSG;
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//FUNCTION PROTOTYPES////////////////////////////////////////////////
int construct();
int process_action();
int process_message();
int destruct();
////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//MAIN FUNCTION DEFINITION///////////////////////////////////////////
int main()
{
 done=0;
 status=stConstruct;
 while(done==0)
      {
       if(status==stConstruct)status=construct();
       if(status==stReflex)status=process_action();
       if(status==stRespond)status=process_message();
       if(status==stDestruct)status=destruct();
      };
return(0);

};
///////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//init FUNCTION DEFINITION///////////////////////////////////
int construct()
{
allegro_init();
initgrafix();

setcolor(15);
DRAW_COLOR=15;
outtextxy(100,100,"grafix going");
oldmsg=new MSG();
MSG_Q=new MSG_QUEUE();
DEVICE_MODULATOR=new Modulator("DEVICE_MODULATOR",1);
kb=new KEY_DEVICE();
MOUSE=new POINTING_DEVICE();



PM=new PaletteModule();



DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)kb);
DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)MOUSE);
DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)PM);
currentMSG=new MSG();
MOUSE->active=1;
kb->active=1;
PM->active=1;
//PM->PC->show();
MOUSE->install();
MOUSE->show();
reflextoggle=0;
respondtoggle=0;

return(stReflex);
};
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//process_action FUNCTION DEFINITION///////////////////////////
int process_action()
{
  hasoldmessage=0;
  reflextoggle++;
  setfillstyle(SOLID_FILL,reflextoggle);
  bar(51,0,100,50);
  //reflextoggle%=255;
 //save the head message
 //at this point the head message should be processed
 //if messages occur they are pushed onto the tail

 if(MSG_Q->PRIMUS!=NULL)
 {
    oldmsg->copy(MSG_Q->GET_PRIMUS_MESSAGE());
    MSG_Q->DELETE_MESSAGE((MSG_NODE *)MSG_Q->PRIMUS);
    hasoldmessage=1;
   };


 //process object natures

 DEVICE_MODULATOR->Reflex();

  if(MSG_Q->PRIMUS==NULL)return(stReflex);

 return(stRespond);
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//process_message FUNCTION DEFINITION////////////////////////////////
int process_message()
{

 respondtoggle++;
 setfillstyle(SOLID_FILL,respondtoggle);
 bar(0,0,50,50);
 respondtoggle%=255;
if(MSG_Q->PRIMUS)
 {
 currentMSG->copy(MSG_Q->GET_PRIMUS_MESSAGE());
 DEVICE_MODULATOR->Respond(currentMSG);
}
 //////////////////////////////////////////////////////////////////////////
 if(currentMSG->message==KEY_PRESS)
    {

     if(((kb->AsciiChar==Escape)&
       (kb->Ctrl==1)))
       {
        return(stDestruct);
       };
     if(((kb->AsciiChar==Escape)&
        (kb->LeftShift==1)))
       {
       };
     if(kb->AsciiChar==Escape)
       {
        return(stDestruct);
       };
    };


 if(currentMSG->message==LBN_PRESS)
     {
      if(MOUSE->pdPOINT.y<500)
      {
      MOUSE->hide();
      putpixel(MOUSE->pdPOINT.x,MOUSE->pdPOINT.y,DRAW_COLOR);
      MOUSE->show();
      };
     };

///////////////////////////////////////////////////////////////////////////
return(stReflex);
}
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////

//Exit FUNCTION DEFINITION///////////////////////////////////////////////
int destruct()
{
MOUSE->install();
MOUSE->hide();
if(MSG_Q!=NULL)delete MSG_Q;
if(DEVICE_MODULATOR!=NULL)delete DEVICE_MODULATOR;


done=1;

return(0);
};
/////////////////////////////////////////////////////////////////////////
