////////////////////////////////////////////////////////////////////////////
class Modulator : public ROTI
{
public:
unsigned int ID;
char *NAME;
unsigned int active;
HMODULE hMODULE;
HMODULE handleholder;
Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
MSG *cMSG;
Modulator(char *n,unsigned int id);
Modulator(char *n);
void initialize(char *n,unsigned int id);
HMODULE GETHANDLE();
virtual void start();
virtual void stop();
virtual void AddModule(char *text,
		  unsigned int id);
void AddModule_primus(unsigned int id);
void add_before_Module(unsigned int id,unsigned int o);
void add_after_Module(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
void INITIALIZE();
void SHUTDOWN();
~Modulator();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//Modulator::Modulator(char *n,unsigned int id):ROTI()
//{
//ID=id;
// NAME=new char [strlen(n)];
// strcpy(NAME,n);
//responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Modulator,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Modulator,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
//active=0;
//};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Modulator::Modulator(char *n,unsigned int id):ROTI()
{
ID=NULL;
NAME=NULL;
active=NULL;
hMODULE=NULL;
handleholder=NULL;
responder=NULL;
reflexor=NULL;
iStart=NULL;
iStop=NULL;
MSGQ=NULL;
cMSG=NULL;
initialize(n,id);
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Modulator::initialize(char *n,unsigned int id)
{
 hMODULE=0;//this could be set to something
 handleholder=0;
 ID=id;
 NAME=new char [strlen(n)];
 cMSG= new MSG();
 strcpy(NAME,n);
responder=new Coordinator();
reflexor=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Modulator,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Modulator,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
active=0;
};
///////////////////////////////////////////////////////////////////////////
void Modulator::INITIALIZE()
{
/* _psp is the starting address of the
	program in memory.  The top of the stack
	is the end of the program.  Using _SS and
	_SP together we can get the end of the
	stack.  You may want to allow a bit of
	saftey space to insure that enough room
	is being allocated ie:
	(_SS + ((_SP + safety space)/16) - _psp)
*/

//keep(0, (_SS + (_SP/16) - _psp));
};
///////////////////////////////////////////////////////////////////

HMODULE Modulator::GETHANDLE()
{
handleholder++;
return(handleholder);
};


///////////////////////////////////////////////////////////////////
void Modulator::SHUTDOWN()
{
//ModuleQ may need to be deleted here ?
//exit(0);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
void Modulator::start()
{

Module *j;
if(active==0)
{
for(j=(Module *)PRIMUS;
	    j;
		 j=(Module *)++(*j))
 {
 };

//responder->Activate(iStop);
//responder->Deactivate(iStart);
active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void Modulator::stop()
{
if(active==1)
{
//responder->Deactivate(iStop);
//responder->Activate(iStart);

 active=0;
};
}
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
void Modulator::AddModule(char *text,
			unsigned int id)
{
 Module *i;
 i=new Module(text,id);
 PUT_MAXIMUS((NEXUS *)i);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Modulator::Respond(MSG *Msg)
{
Module *x;

cMSG->copy(Msg);
//here the modulator can respond to messages
//maybe change them or redirect them
//	    printf("s","modulator.respond");
responder->Respond(cMSG,this);

//0 means broadcast to all
if(Msg->hModule==0)
for(x = (Module *)PRIMUS;
		       x;
		       x =(Module *) ++(*x)) x->Respond(cMSG);
//not 0 means broadcast solo

if(Msg->hModule!=0){/////////////////////////
     //first find the module
     //that has the same
     //handle as the message
      // printf("modulator.respond","s");
     for(x = (Module *)PRIMUS;
	 x;
	 x =(Module *) ++(*x))
			      {////////////////////////////
			      if(x->hMODULE==Msg->hModule){///////////////

							   x->Respond(Msg);
							   break;
							   };/////////////
			      };///////////////////////////
    };////////////////////////


};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void Modulator::Reflex()
{
Module *x;
reflexor->Reflex(this);
for(x=(Module *)PRIMUS;
	 x;
	 x=(Module *)++(*x))x->Reflex();
};
/////////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
void Modulator::add_before_Module(unsigned int id,unsigned int o)
{
 Module *i,*j;
 i=new Module(id);
 for(j=(Module *)PRIMUS;\
			j->ID!=o;\
			j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Modulator::add_after_Module(unsigned int id,unsigned int o)
{
 Module *i,*j;
 i=new Module(id);
 for(j=(Module *)PRIMUS;\
			j->ID!=o;\
			j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Modulator::~Modulator()
{
Module *temp;
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
if(cMSG)delete cMSG;
if(responder)delete responder;
if(reflexor)delete reflexor;
//if(background!=NULL)delete (background);
if(NAME)delete (NAME);


/*
if(PRIMUS!=NULL)
 {
  Module* NEXT;
  Module* current = (Module *)PRIMUS;
  for(;;)
	  {
		NEXT=(Module *)current->next;
		if(current!=NULL)delete current;
		if(NEXT == NULL)break;
		current=NEXT;
	  };
  };
*/




if((PRIMUS!=NULL)&&(MAXIMUS!=NULL))//if not emptty
{
 NEXUS *temp=PRIMUS;

 for(Module *current=(Module *)PRIMUS;         //start on PRIMUS
             current;                 //Stop after Maximus
                          )          //increment current
    {
     current=(Module *)current->next;
     delete (Module *)temp;
     temp=current;
    }

}

};
////////////////////////////////////////////////////////////////////////////
