////////////////////////////////////////////////////////////////////////////
class Module : public ROTI
{
public:
unsigned int ID;
char *NAME;
unsigned int active;
HMODULE hMODULE;
Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
MSG *cMSG;
Module(char *n,unsigned int id);
Module(char *n);
void initialize(char *n,unsigned int id);
virtual void start();
virtual void stop();
virtual void AddConsole(char *text,
		  unsigned int id);
void AddConsole_primus(unsigned int id);
void add_before_Console(unsigned int id,unsigned int o);
void add_after_Console(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
void INITIALIZE();//!!!!WARNING!!!!!!!!
void SHUTDOWN();
~Module();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//Module::Module(char *n,unsigned int id):ROTI()
//{
//ID=id;
// NAME=new char [strlen(n)];
// strcpy(NAME,n);
//responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Module,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Module,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
//active=0;
//};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Module::Module(char *n,unsigned int id):ROTI()
{
hMODULE=NULL;
ID=NULL;
NAME=NULL;
MSG_Q=NULL;
cMSG=NULL;
reflexor=NULL;
responder=NULL;
iStart=NULL;
iStop=NULL;
initialize(n,id);
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Module::initialize(char *n,unsigned int id)
{
 hMODULE=GetModuleHandle();
 ID=id;
 NAME=new char [strlen(n)];
 cMSG= new MSG();
 strcpy(NAME,n);
responder=new Coordinator();
reflexor=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Module,RBN_RELEASE,start);
//iStop=responder->MAKE_RESPONSE(Module,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
active=0;
};
///////////////////////////////////////////////////////////////////////////
void Module::INITIALIZE()
{
/* _psp is the starting address of the
	program in memory.  The top of the stack
	is the end of the program.  Using _SS and
	_SP together we can get the end of the
	stack.  You may want to allow a bit of
	saftey space to insure that enough room
	is being allocated ie:
	(_SS + ((_SP + safety space)/16) - _psp)
*/

//keep(0, (_SS + (_SP/16) - _psp));
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void Module::SHUTDOWN()
{
//ConsoleQ may need to be deleted here ?
//exit(0);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
void Module::start()
{

Console *j;
if(active==0)
{
for(j=(Console *)PRIMUS;
	    j;
		 j=(Console *)++(*j))
 {
 };

//responder->Activate(iStop);
//responder->Deactivate(iStart);
active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void Module::stop()
{
if(active==1)
{
//responder->Deactivate(iStop);
//responder->Activate(iStart);

 active=0;
};
}
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
void Module::AddConsole(char *text,
			unsigned int id)
{
 Console *i;
 i=new Console(hMODULE,text,id);
 PUT_MAXIMUS((NEXUS *)i);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Module::Respond(MSG *Msg)
{
Console *x;
cMSG->copy(Msg);
//printf("IN MOD RESPOND","s");
responder->Respond(cMSG,this);
for(x = (Console *)PRIMUS;
	 x;
	 x =(Console *) ++(*x)) x->Respond(cMSG);

};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void Module::Reflex()
{
Console *x;
reflexor->Reflex(this);
for(x=(Console *)PRIMUS;
	 x;
	 x=(Console *)++(*x))x->Reflex();
};
/////////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
void Module::add_before_Console(unsigned int id,unsigned int o)
{
 Console *i,*j;
 i=new Console(id);
 for(j=(Console *)PRIMUS;\
			j->ID!=o;\
			j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Module::add_after_Console(unsigned int id,unsigned int o)
{
 Console *i,*j;
 i=new Console(id);
 for(j=(Console *)PRIMUS;\
			j->ID!=o;\
			j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Module::~Module()
{
//responder->Deactivate(iStart);
//responder->Deactivate(iStop);
if(responder)delete responder;
if(reflexor)delete reflexor;
	 if(cMSG)delete cMSG;
//if(background!=NULL)delete (background);
if(NAME)delete (NAME);
if(PRIMUS)
 {
  Console* NEXT;
  Console* current = (Console *)PRIMUS;
  for(;;)
	  {
		NEXT=(Console *)current->next;
		if(current)delete current;
		if(!NEXT)break;
		current=NEXT;
	  };
  };
};
////////////////////////////////////////////////////////////////////////////
