////////////////////////////////////////////////////////////////////////////
class PortalQ : public ROTI
{
public:

char *NAME;
unsigned int active;
Coordinator *responder;
impulse *iStart,*iStop;
MSG_Q *MSGQ;
PortalQ(int x,int y,char *n);
void start();
void stop();
void save_background();
void restore_background();
void AddItem(char *text,
		  unsigned int id);
void AddItem_primus(unsigned int id);
void add_before_Portal(unsigned int id,unsigned int o);
void add_after_Portal(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
void show();
void hide();
~PortalQ();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
PortalQ::PortalQ(int x,int y,char *n):ROTI(),RECT(x,y,
					    strlen(n)*textwidth("W"),3)
{
name=new char[strlen(n)];
//QMOUSE=&MOUSE;
backgroundsize=imsize(right-left,top-bottom);
background=new char far[backgroundsize];
strcpy(name,n);
pixelwidth=0;
responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(PortalQ,RBN_RELEASE,start);
iStop=responder->MAKE_RESPONSE(PortalQ,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
cMSG=new MSG();
active=0;
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void PortalQ::start()
{
int sx,sy,c,x,y;
Portal *j;
if(active==0)
{
c=0;
sx=right-left;
sy=bottom-top;
setpoints(MOUSE.pdPOINT.x,
	  MOUSE.pdPOINT.y,
	  MOUSE.pdPOINT.x+sx,
	  MOUSE.pdPOINT.y+sy);
for(j=(Portal *)PRIMUS;
	    j!=NULL;
	    j=++(*j))
 {
 x=left+2;
 y=top+(c*(textheight("W")+3));
 j->setpoints(x,y,x+pixelwidth,y+textheight("W")+4);
 c++;
 };
show();
FOR_EACH((pMF)(&Portal::startMOUSE_MOVE_IMPULSES));
responder->Activate(iStop);
//responder->Deactivate(iStart);
active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void PortalQ::stop()
{
if(active==1)
{
responder->Deactivate(iStop);
//responder->Activate(iStart);
FOR_EACH((pMF)(&Portal::stopMOUSE_MOVE_IMPULSES));
hide();
 active=0;
};
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void PortalQ::save_background()
{
 getimage(left,top,right,bottom,background);
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void PortalQ::restore_background()
{
  putimage(left,top,background,COPY_PUT);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void PortalQ::AddItem(char *text,
		   unsigned int id)
{
 int x,y,sx,sy,c;
 Portal *i,*j;
 c=0;
 for(j=(Portal *)PRIMUS;
	      j!=NULL;
	      j=++(*j))c++;
 x=left+2;y=top+(c*(textheight("W")+3));
 sx=textwidth(text)+8;
 if(sx>pixelwidth)
   {
    pixelwidth=sx;
    for(j=(Portal *)PRIMUS;
	j!=NULL;
	j=(Portal *)j->next)j->right=j->left+pixelwidth;
   }
 sx=pixelwidth;
 right=left+pixelwidth+4;
 sy=textheight("W")+4;
 i=new Portal(x,y,sx,sy,text,id);
 PUT_MAXIMUS((NEXUS *)i);
 bottom=(bottom)+(textheight("W")+3);
 backgroundsize=imsize(right-left,top-bottom);
 if(background!=NULL)delete background;
 backgroundsize=imsize(right-left,top-bottom);
 background=new char far[backgroundsize];
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void PortalQ::Respond(MSG *Msg)
{
Portal *x;
cMSG->copy(Msg);
responder->Respond(cMSG,this);
for(x = (Portal *)PRIMUS;
    x != NULL;
    x = ++(*x)) x->Respond(cMSG);
};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void PortalQ::Reflex()
{
Portal *x;
for(x=(Portal *)PRIMUS;
    x!=NULL;
    x=++(*x))x->reflexor->Reflex(x);
};
/////////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
void PortalQ::add_before_Portal(unsigned int id,unsigned int o)
{
 Portal *i,*j;
 i=new Portal(id);
 for(j=(Portal *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void PortalQ::add_after_Portal(unsigned int id,unsigned int o)
{
 Portal *i,*j;
 i=new Portal(id);
 for(j=(Portal *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void PortalQ::show()
{
MOUSE.hide();
save_background();
raisedbar(left,top,right,bottom,7);
FOR_EACH((pMF)(&Portal::show));
MOUSE.show();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void PortalQ::hide()
{   MOUSE.hide();
restore_background();
MOUSE.show();
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
PortalQ::~PortalQ()
{
//responder->Deactivate(iStart);
responder->Deactivate(iStop);
if(cMSG!=NULL)delete cMSG;
if(responder!=NULL)delete responder;
if(background!=NULL)delete (background);
if(name!=NULL)delete (name);
if(PRIMUS!=NULL)
 {
  Portal* NEXT;
  Portal* current = (Portal *)PRIMUS;
  for(;;)
     {
      NEXT=(Portal *)current->next;
      if(current!=NULL)delete current;
      if(NEXT == NULL)break;
      current=NEXT;
     };
  };
};
////////////////////////////////////////////////////////////////////////////
