//#include<_defs.h>
#include <dos.h>
#include <stdlib.h>
//#include<fcntl.h>
/* The clock tick interrupt */
#define TIMER_INTR 0x1C
/* The keyboard interrupt */
#define KEYBOARD_INTR 0x09

#define rightshift 1
#define leftshift 2
#define ctrl 4
#define alt 8

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif
extern unsigned int _psp;
volatile int count;
volatile int MAX_COUNT;
char ticks;
char flag;
volatile int saving_screen;
int ROWS,COLS;
char MODE,CURSOR_ROW,CURSOR_COL,SPRITE_ROW,SPRITE_COL;
char PAGE,PAGE2;

/* reduce heaplength and stacklength to make a smaller program in memory */
extern unsigned _heaplen = 1024;
extern unsigned _stklen  = 512;

void interrupt ( *oldtimerhandler)(__CPPARGS);
void interrupt ( *oldkeyboardhandler)(__CPPARGS);


void interrupt timerhandler(__CPPARGS)
{
	 //call the old handler
	 oldtimerhandler();
  /* increase the counter  */
   count++;
   if((count==MAX_COUNT)&&(saving_screen==0))
      {
       save_screen();
       count=0;
      }else{
	     if(saving_screen==1)
	       {
		 if(count==5)
		   {
		    count=0;
		    putstring(SPRITE_ROW,
			    SPRITE_COL,
			    PAGE2,
			    "           ",
			    0,
			    1);
		    SPRITE_ROW++;
		    SPRITE_COL++;
		    if(SPRITE_ROW>=ROWS)SPRITE_ROW=0;
		    if(SPRITE_COL>=COLS)SPRITE_COL=0;
		    putstring(SPRITE_ROW,
			    SPRITE_COL,
			    PAGE2,
			    "SCREENSAVER",
			    4,
			    1);
		  };
		};
	   };


}



int main(int argc,char *argv[])
{
int OLDTSEG,OLDTOFF,OLDKSEG,OLDKOFF;

count=0;
MAX_COUNT=546;
saving_screen=0;
SPRITE_ROW=1;
SPRITE_COL=1;

if(argc>1)MAX_COUNT=(atoi(argv[1])*18);
/* get the address of the current clock
   tick interrupt */
oldtimerhandler = getvect(TIMER_INTR);
   /* install the new interrupt handler */
setvect(TIMER_INTR, timerhandler);

//get the address of the current keyboard interrupt
oldkeyboardhandler = getvect(KEYBOARD_INTR);

//install the new interrupt handler
setvect(KEYBOARD_INTR, keyboardhandler);

keep(0, 522);
return 0;
}
