void save_screen(void);
void restore_screen(void);
void puttext(char row,char col,char page,char character,char attr,char num);
void putstring(char row,char col,char page,char *str,char attr,char num);

void putstring(char row,char col,char page,char *str,char attr,char num)
{
for(int x=0;str[x]!=NULL;x++)
	{
	puttext(row,(col+x),page,str[x],attr,num);
	}
};

void puttext(char row,char col,char page,char charac,char attr,char num)
{
	asm{
				 mov ah,2;//set cursor position
				 mov DH,col;//column
				 mov DL,row;//row
				 mov bh,page;//page
				 int 10h
				 mov ah,9 //subfunction to write character and attribute
				 mov bh,page //page 0
				 mov al,charac //character
				 mov bl,attr; //attribute
				 mov cl,num;//#repeat
				 mov ch,0;
				 int 10h  //video interrupt

			 };
};

void interrupt keyboardhandler(__CPPARGS)
{
oldkeyboardhandler();
if(saving_screen==1)
  {
	restore_screen();
  };
count=0;
}

void save_screen(void)
{
int index;
char x,y;
char character,attribute;
index=0;
asm {
	  mov ah,15;//sub function get video mode
	  int 10h;//video interrupt
	  mov MODE,al;
     mov PAGE,BH;
	  };

//set ROWS and COLS according to video mode
if((MODE==0)||(MODE==1)||(MODE==4)||(MODE==5)||(MODE==9)||(MODE==13)||(MODE==19))
  {
	ROWS=40;COLS=25;
  };
if((MODE==2)||(MODE==3)||(MODE==6)||(MODE==10)||(MODE==14)||(MODE==15)||(MODE==16))
{
 ROWS=80;COLS=25;
};
if((MODE==17)||(MODE==18))
{
ROWS=80;COLS=30;
};
if(MODE==8)
{
ROWS=20;COLS=25;
};
////////////////////////////////////////////////////////////////////////


//get cursor ROW, COLUMN, and ATTRIBUTE
asm{
	 mov ah,3;//subfunction to get CURSOR POSITION
	 int 10h;
	 mov CURSOR_ROW,DH;
    mov CURSOR_COL,DL;
	};


      PAGE2=PAGE+1;
		asm{
      mov ah,5h
		mov al,PAGE2;
      int 10h;
		};

///////////////////////////////////////////////////////

//blank the screen//////////////////////////////////
//index=0;
for(x=0;x<COLS;x++)
	 {
	  for(y=0;y<ROWS;y++)
	{
		 //character=videochar[index];
		 //attribute=videoattr[index];
			puttext(y,
				x,
				PAGE2,
			   255,
				0,
			   1);

	};
	 };
////////////////////////////////////////////////////
saving_screen=1;
};

void restore_screen(void)
{
int index;
char x,y;
char character,attribute;
//restore the screen//////////////////////////////////
saving_screen=0;
//index=0;


 asm{
	  mov ah,5h;
	  mov al,PAGE;
	  int 10h;
	  };

	 asm{
			mov ah,2;//set cursor position
			mov DH,CURSOR_ROW;
			mov DL,CURSOR_COL;
			mov bh,PAGE;
			int 10h
	      };
////////////////////// //////////////////////////////

}