/* Sample program that initializes the SuperVGA driver */

#include <stdio.h>
#include<stdlib.h>
#include <conio.h>
#include<bios.h>
#include<dos.h>
#include <graphics.h>
#include<objects.h>
//#include<msgqueue.h>
#include <mouse.h>
#include <keyboard.h>
#include "svgautil.h"
#include "svga256.h"


/* Returns the color for white */
long WhitePixel()
{
  switch(getmaxcolor()) {
    case 32768: return 0x7fffL;
    case 65535: return 0xffffL;
    case 16777: return 0xffffffL;
    default   : return 15;
  };
}

int huge DetectVGA256()
{
  int Vid;
 /*
    0 = 320x200x256
    1 = 640x400x256
    2 = 640x480x256
    3 = 800x600x256
    4 = 1024x768x256
    5 = 640x480x256
    6 = 1280x1024x256
 */
 Vid=2;
  return Vid;
};


void main()
{
  int  Gd = DETECT, Gm;
  int  Drv;
  char GrErr;

installuserdriver("Svga256",DetectVGA256);
/*  If driver is linked with file, remove comments */
/*          registerfarbgidriver(Svga256_fdriver); */



  initgraph(&Gd,&Gm,"d:\\tc\\bgi");

  /* Test if mode was initialized successfully */
  GrErr = graphresult();
  if (GrErr != grOk) {
      printf("Graphics error: %s\n",grapherrormsg(GrErr));
      exit(1);
  }

  INSTALL_MOUSE_HANDLER();
  m.install();
  m.show();
  /* Draw an 'X' on the screen */
  setcolor(15);

  line(0,0,getmaxx(),getmaxy());
  line(0,getmaxy(),getmaxx(),0);
  getch();
  closegraph();
}
