
class editbox:public Component
{
public:
String *text;
int CURSOR_POSITION;
impulse *ipID;
RECT *CURSOR;
RECT *POINTCHECK;
POINT TEXT;
POINT VTEXT;
editbox(int left,int top,int sizex,int sizey,char *txt,int Idd);
void makertable();
void ADJUST_TEXT_POS();
void ADJUST_TEXT_NEG();
void KEY_PRESS_LEFT();
void KEY_PRESS_RIGHT();
void KEY_PRESS_HOME();
void KEY_PRESS_END();
void KEY_PRESS_BACKSPACE();
void KEY_PRESS_DELETE();
void KEY_PRESS_ASCIICHAR();
void KEY_HANDLER();
void CALC_CURSOR_COORD();
virtual void rspKEY_PRESS();
virtual void show();
virtual void move(int deltax,int deltay);
void selectableidfunc();
char *gettext();
void settext(char *c);
//void settext(char *s);
~editbox();
};

/////////////////////////////////////////////////////////////////////////////
editbox::editbox(int left,
		 int top,
		 int sizex,
		 int sizey,
		 char *txt,
		 int Idd):Component(left,
				 top,
				 sizex,
				 sizey,
				 txt,
				 Idd)
{

text=new String(256);
settext(txt);
TEXT.x=this->left;
TEXT.y=this->top+5;
VTEXT.x=0;
VTEXT.y=0;
CURSOR=new RECT(left+1,textheight("W")+5+top,textwidth("W"),0);
POINTCHECK=new RECT(left,top,textwidth("W"),bottom-top);
CURSOR_POSITION=0;
makertable();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::show()
{
   loweredbar(left,top,right,bottom,7);
   setviewport(left+1,top+1,right-1,bottom-1,1);
   VTEXT.x=TEXT.x-left;
   setcolor(0);
   outtextxy(VTEXT.x+1,VTEXT.y,text->char_ptr);
   setviewport(0,0,639,479,0);
   if(textwidth(text->char_ptr)!=0)line(CURSOR->left+1,CURSOR->top,CURSOR->right-1,CURSOR->top);
};
/////////////////////////////////////////////////////////////////////////////
void editbox::settext(char *c)
{
 strcpy(text->char_ptr,c);
 KEY_PRESS_HOME();
};
/////////////////////////////////////////////////////////////////////////////
void editbox::makertable()
{
ipID=responder->MAKE_RESPONSE(editbox, ID, selectableidfunc);
};

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////

void editbox::rspKEY_PRESS()
{
 if(kb.ScanCode==Tab){;};
 if(kb.ScanCode==LeftArrow)if(CURSOR_POSITION!=0)KEY_PRESS_LEFT();
 if(kb.ScanCode==RightArrow)if(CURSOR_POSITION!=text->Get_len())KEY_PRESS_RIGHT();
 if(kb.ScanCode==Home)if(CURSOR_POSITION!=0)KEY_PRESS_HOME();
 if(kb.ScanCode==End)if(CURSOR_POSITION!=text->Get_len())KEY_PRESS_END();
 if(kb.ScanCode==Delete)if(CURSOR_POSITION!=text->Get_len())KEY_PRESS_DELETE();
 if(kb.AsciiChar==BackSpace)if(CURSOR_POSITION!=0)KEY_PRESS_BACKSPACE();
 if(kb.AsciiChar>=28)if(text->Get_len()!=255)KEY_PRESS_ASCIICHAR();

 /*
 textbox(1,100,"left: ",left);
 textbox(1,112,"TEXT.x: ",TEXT.x);
 textbox(1,124,"right: ",right);
 textbox(1,136,"VTEXT.x: ",VTEXT.x);
 textbox(1,148,"CURSOR->left: ",CURSOR->left);
 textbox(1,160,"CURSOR->right: ",CURSOR->right);
 textbox(1,172,"CURSOR_POSITION: ",CURSOR_POSITION);
 textbox(1,184,"text length: ",text->Get_len());
 textbox(1,196,text->char_ptr);
 */
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::CALC_CURSOR_COORD()
{
 int width;
 width=0;
 for(int count=0;count<CURSOR_POSITION;count++)
    {
     width=charwidth(text->char_ptr[count])+width;
    };
 CURSOR->left=TEXT.x+width;
 if(text->char_ptr[CURSOR_POSITION]!='\0'){
 CURSOR->right=CURSOR->left+charwidth(text->char_ptr[CURSOR_POSITION]);
 }else CURSOR->right=CURSOR->left+textwidth("W");
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::selectableidfunc()
{
 int width;
 POINT checkpoint;

 width=0;
 POINTCHECK->left=TEXT.x;
 for(int count=0;count<text->Get_len();count++)
    {
     POINTCHECK->left=TEXT.x+width;
     width=charwidth(text->char_ptr[count])+width;
     POINTCHECK->right=TEXT.x+width;
     if(POINTCHECK->pointinrect((POINT *)&cMSG->pt))
	{
	 if(count<CURSOR_POSITION)
	    {
	     CURSOR_POSITION=count;
	     ADJUST_TEXT_NEG();
	    }else {
		   CURSOR_POSITION=count;
		   ADJUST_TEXT_POS();
		  };
	  break;
	};
    };
    /*
    textbox(10,200,"left: ",POINTCHECK->left);
    textbox(10,212,"right: ",POINTCHECK->right);
    textbox(10,224,"top: ",POINTCHECK->top);
    textbox(10,232,"bottom: ",POINTCHECK->bottom);
    */
    show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::ADJUST_TEXT_NEG()
{
CALC_CURSOR_COORD();
 if(CURSOR->left<left)
    {
     TEXT.x=left-CURSOR->left+TEXT.x;
     CALC_CURSOR_COORD();
    };
};
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
void editbox::ADJUST_TEXT_POS()
{
CALC_CURSOR_COORD();
 if(CURSOR->right>right)
    {
     TEXT.x=TEXT.x-(CURSOR->right-right);
     CALC_CURSOR_COORD();
    };
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_LEFT()
{
 CURSOR_POSITION=CURSOR_POSITION-1;
 ADJUST_TEXT_NEG();
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_RIGHT()
{
 CURSOR_POSITION=CURSOR_POSITION+1;
 ADJUST_TEXT_POS();
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_HOME()
{
 CURSOR_POSITION=0;
 ADJUST_TEXT_NEG();
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_END()
{
 CURSOR_POSITION=text->Get_len();
 ADJUST_TEXT_POS();
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_BACKSPACE()
{
 CURSOR_POSITION=CURSOR_POSITION-1;
 text->DELETE_CHAR(CURSOR_POSITION);
 ADJUST_TEXT_NEG();
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_DELETE()
{
 text->DELETE_CHAR(CURSOR_POSITION);
 show();
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::KEY_PRESS_ASCIICHAR()
{
 text->INSERT_CHAR(CURSOR_POSITION,kb.AsciiChar);
 CURSOR_POSITION=CURSOR_POSITION+1;
 ADJUST_TEXT_POS();
 show();
};
/////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
char *editbox::gettext()
{
return(text->char_ptr);
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//void settext(char *s)
//{
//
//};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void editbox::move(int deltax,int deltay)
{
 Component::move(deltax,deltay);
 CURSOR->move(deltax,deltay);
 POINTCHECK->move(deltax,deltay);
 TEXT.x=TEXT.x+deltax;
 TEXT.y=TEXT.y+deltay;
};
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
editbox::~editbox()
{
 if(text!=NULL)delete text;
 if(CURSOR!=NULL)delete CURSOR;
 if(POINTCHECK!=NULL)delete POINTCHECK;
};
/////////////////////////////////////////////////////////////////////////////