//////////////////////////////////////////////////////////////////////////
class GxComponent :public Component, public RECT
{
public:
int ForegroundColor,BackgroundColor;
GxComponent(char *n,unsigned int i,int l,int t,int sx,int sy);
void setForegroundColor(int c);
void setBackgroundColor(int c);
virtual void show(void);
~GxComponent();
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
GxComponent::GxComponent(char *n,unsigned int i,int l,int t,int sx,int sy)
       :Component(n,i)
       ,RECT(l,t,sx,sy)
{
     ForegroundColor=WHITE;
     BackgroundColor=BLACK;
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void GxComponent::show(void)
{
setcolor(BackgroundColor);
bar(left,top,right,bottom);
setcolor(ForegroundColor);
outtextxy(NAME);
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void GxComponent::setForegroundColor(int c)
{
ForegroundColor=c;
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void GxComponent::setBackgroundColor(int c)
{
BackgroundColor=c;
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
GxComponent::~GxComponent()
{
};
//////////////////////////////////////////////////////////////////////////

