//#include<fstream.h>
//#include <string.h>
//#include<conio.h>
#define SELECTED_SELECTED 1400
///////////////////////////////////////////////////////////////////
class node
{
 public:
 char item[16];
 int id;
 int color;
 node* next;
 node* previous;
 node(char *s,int c=White){strcpy(item,s);color=c;}
 ~node(){}
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
class listbox :public QOM
{

  public:
 node *first;
 node *last;
 node *head,*tail;
 node *boxhead;
 node *boxtail;
 node *selectednode;
 int size;
 scrollbar *scroll;
 listbox(QOM *owner,int l,int t,int w,int d,int id);
 void additem(char *string,int c=White);
 void fill();
 virtual void draw();
 void scrollprev();
 void scrollnext();
 void select_item();
 virtual void selectableidfunc();
// virtual void move(int deltax,int deltay);
 void flush();
 void write(char*);
 void read(char*);
 void Scrolldown();
 void Scrollup();
 void Scrollslider();
 ~listbox();
};
///////////////////////////////////////////////////////////////////

listbox::listbox(QOM *owner,int l,int t,int w,int d,int id):QOM(owner,l,t,w,d,id,PA_STATIC)
{
 first=NULL;
 last=NULL;
 head=NULL;
 tail=NULL;
 boxhead=NULL;
 boxtail=NULL;
 // left=l;
// top=t;
// right=l+w;
// bottom=t+d;
 size=d/textheight("W");
 scroll=new scrollbar(owner,
		     right+1-owner->left,
		     top-owner->top,
		     13,
		     sizey,
		     1,
		     1,
		     4000);
 DEFINE_NATURE(listbox,&scroll->negpb->pressedinportal,1,Scrolldown);
 DEFINE_NATURE(listbox,&scroll->pospb->pressedinportal,1,Scrollup);
 DEFINE_RESPONSE(listbox,SC_SLIDER,Scrollslider);
 }

// void listbox::move(int deltax,int deltay)
// {
  //RECT::move(deltax,deltay);
  //scroll->move(deltax,deltay);
//  };
 ///////////////////////////////////////////////////////////////////////////
void listbox::Scrolldown()
{
scroll->scrolldown();
scrollnext();
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void listbox::Scrollup()
{
scroll->scrollup();
scrollprev();
};
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
void listbox::Scrollslider()
{
scroll->scrolldown();
};
///////////////////////////////////////////////////////////////////////////


void listbox::selectableidfunc()
{
QOM::selectableidfunc();
select_item();
};

void listbox::select_item()
{
RECT *CHECKER;
CHECKER=new RECT(left+1,top+5,right-1-left,textheight("W")+2);
 node* current = boxhead;
  //loweredbar(left,top,right,bottom,MediumGrey);
  //setviewport(left+1,top+1,right-1,bottom-1,1);

    // setcolor(Yellow);
 for(int g=0;g<=size;g++)
    {
     if(CHECKER->pointinrect(&msg->pt))
	{
	  if(current==selectednode)POST_MESSAGE(hPortal,
						SELECTED_SELECTED,
						NULL,
						NULL,
						msg->pt);
	  else  selectednode=current;
	  //textbox(left,top-20,selectednode->item);
	  break;
	};
	CHECKER->top=CHECKER->top+textheight("W");
	CHECKER->bottom=textheight("W")+CHECKER->top;
     //outtextxy(2,(textheight(" ")*g)+2,current->item);
     if(current->next == NULL)break;
     current=current->next;
    }
   // setviewport(0,0,639,479,1);
   delete CHECKER;
   show();
};
///////////////////////////////////////////////////////////////////
void listbox::additem(char *s,int c)
{
 node* newnode = new node(s,c);
 newnode->previous = first;
 newnode->next = NULL;
 if(newnode->previous!=NULL)newnode->previous->next=newnode;
 else{
      head=newnode;
      }
 scroll->increase_range(1);
 first = newnode;
 tail =newnode;
}
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void listbox::fill()
{
boxhead=head;
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void listbox::draw()
{
 node* current = boxhead;
  loweredbar(left,top,right,bottom,LightLightGrey);
  setviewport(left+1,top+1,right-1,bottom-1,1);

 if(boxhead!=NULL)
 {
 for(int g=0;g<=size;g++)
    {
     if((current==selectednode)&&(selectednode!=NULL))
       {
	setfillstyle(1,White);
	bar(1,
	    (textheight("W")*g)+4,
	    right-left-2,
	    (textheight("W")*g)+textheight("W")+4);
	setcolor(current->color);
	outtextxy(2,(textheight("W")*g)+2,current->item);
	//setcolor(Yellow);
	}else{
	       setcolor(current->color);
	       outtextxy(2,(textheight("W")*g)+2,current->item);
	     };
     if(current->next == NULL)break;
     current=current->next;
    }
    setviewport(0,0,639,479,1);
    scroll->draw();
 };
}
///////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////
void listbox::scrollprev()
{
if(boxhead->previous!=NULL)boxhead=boxhead->previous;
show();
};

void listbox::scrollnext()
{
 if(boxhead->next!=NULL)boxhead=boxhead->next;
 show();
};


void listbox::write(char* fname)
{
 ofstream outfile;
 outfile.open(fname);
 node* current=first;
 while(current!=NULL)
      {
       outfile.write((char*)&current->item,sizeof(int));
       current=current->next;
      }
 outfile.close();
}
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void listbox::read(char* fname)
{
/* int tempint;
 ifstream infile;
 infile.open(fname,ios::nocreate);
 while(1)
      {
       infile.read((char*)&tempint,sizeof(int));
       if(infile.eof())
       break;
       additem(tempint);
      } */
}
///////////////////////////////////////////////////////////////////
void listbox::flush()
{
 if(head!=NULL)
 {
  node* current = head;
  for(;;)
     {
      delete current;
      if(current->next == NULL)break;
      current=current->next;
     }
  }
  scroll->range=0;
 scroll->position=0;
 scroll->reposition();
  head=NULL;
  first=NULL;
 last=NULL;
  tail=NULL;
 boxhead=NULL;
 boxtail=NULL;
 selectednode=NULL;
 draw();
}

///////////////////////////////////////////////////////////////////
listbox::~listbox()
{
 if(head!=NULL)
 {
  node* current = head;
  for(;;)
     {
      delete current;
      if(current->next == NULL)break;
      current=current->next;
     }
  }
}
///////////////////////////////////////////////////////////////////


