////////////////////////////////////////////////////////////////////////////
class MouseTrap:  public  Component,public RECT
{
public:
POINTING_DEVICE *QMOUSE;
KEY_DEVICE *QKEYBOARD;
unsigned int MOUSE_IN,MOUSE_OUT,MOUSE_REL,LBN_PRESS_IN,RBN_PRESS_IN;
impulse *ipLBN_PRESS,*ipLBN_RELEASE,
	*ipRBN_PRESS,*ipRBN_RELEASE,
	*ipMOUSE_MOVE,*ipMOUSE_IN,*ipMOUSE_OUT,
	*ipKEY_PRESS;

MouseTrap(HMODULE hMOD,
	 int left,
	 int top,
	 int sizex,
	 int sizey,
	 char *text,
	 unsigned int id);
MouseTrap *operator ++(){return ((MouseTrap *)next);};
MouseTrap *operator --(){return ((MouseTrap *)previous);};
 void startMOUSE_MOVE_IMPULSES();
 void stopMOUSE_MOVE_IMPULSES();
 void startMOUSE_BUTTON_IMPULSES();
 void stopMOUSE_BUTTON_IMPULSES();
 void startKEY_PRESS_IMPULSE();
 void stopKEY_PRESS_IMPULSE();
 virtual void show();
 virtual void show2();
 void rfxMOUSE_IN();
 void rfxMOUSE_OUT();
 void rspLBN_PRESS();
 void rspLBN_RELEASE();
 void rspRBN_PRESS();
 void rspRBN_RELEASE();
 void rspMOUSE_MOVE();

 virtual void actionMOUSE_IN();
 virtual void actionMOUSE_OUT();
 virtual void actionLBN_PRESS_IN();
 virtual void actionLBN_RELEASE_IN_LBN_PRESS_IN();
 virtual void actionLBN_RELEASE_IN_LBN_PRESS_NOT_IN();
 virtual void actionLBN_RELEASE_NOT_IN();
 virtual void actionRBN_PRESS_IN();
 virtual void actionRBN_RELEASE_IN_RBN_PRESS_IN();
 virtual void actionRBN_RELEASE_IN_RBN_PRESS_NOT_IN();
 virtual void actionRBN_RELEASE_NOT_IN();
 virtual void rspKEY_PRESS();
 void kpCtrlEscape();
 //virtual void Respond(MSG *Msg);
 ~MouseTrap();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
MouseTrap::MouseTrap(HMODULE hMOD,
		     int left,
		     int top,
		     int sizex,
		     int sizey,
		     char *text,
		     unsigned int id):Component(hMOD,text,id),
				   RECT(left,top,sizex,sizey)
{
 QMOUSE=MOUSE;
 LBN_PRESS_IN=FALSE;
 RBN_PRESS_IN=FALSE;
 MOUSE_IN=FALSE;
 MOUSE_OUT=FALSE;
 MOUSE_REL=OUT;
 ipMOUSE_MOVE=responder->MAKE_RESPONSE(MouseTrap, MOUSE_MOVE, rspMOUSE_MOVE);
 ipLBN_PRESS=responder->MAKE_RESPONSE(MouseTrap, LBN_PRESS, rspLBN_PRESS);
 ipLBN_RELEASE=responder->MAKE_RESPONSE(MouseTrap, LBN_RELEASE, rspLBN_RELEASE);
 ipRBN_PRESS=responder->MAKE_RESPONSE(MouseTrap, RBN_PRESS, rspRBN_PRESS);
 ipRBN_RELEASE=responder->MAKE_RESPONSE(MouseTrap, RBN_RELEASE, rspRBN_RELEASE);
 ipKEY_PRESS=responder->MAKE_RESPONSE(MouseTrap, KEY_PRESS, rspKEY_PRESS);
 ipMOUSE_IN=reflexor->MAKE_REFLEX(MouseTrap, &MOUSE_IN, 1, rfxMOUSE_IN);
 ipMOUSE_OUT=reflexor->MAKE_REFLEX(MouseTrap, &MOUSE_OUT, 1, rfxMOUSE_OUT);
 responder->Deactivate(ipLBN_PRESS);
 responder->Deactivate(ipLBN_RELEASE);
 responder->Deactivate(ipRBN_PRESS);
 responder->Deactivate(ipRBN_RELEASE);
 stopMOUSE_MOVE_IMPULSES();
 stopKEY_PRESS_IMPULSE();
 //cMSG=new MSG();
};
////////////////////////////////////////////////////////////////////////////

/*/////////////////////////////////////////////////////////////////////////
void MouseTrap::Respond(MSG *Msg)
{
cMSG->copy(Msg);
responder->Respond(cMSG,this);
}
/*/////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::startMOUSE_MOVE_IMPULSES()
{
responder->Activate(ipMOUSE_MOVE);
reflexor->Activate(ipMOUSE_IN);
reflexor->Activate(ipMOUSE_OUT);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::stopMOUSE_MOVE_IMPULSES()
{
responder->Deactivate(ipMOUSE_MOVE);
reflexor->Deactivate(ipMOUSE_IN);
reflexor->Deactivate(ipMOUSE_OUT);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::startKEY_PRESS_IMPULSE()
{
responder->Activate(ipKEY_PRESS);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::stopKEY_PRESS_IMPULSE()
{
responder->Deactivate(ipKEY_PRESS);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::startMOUSE_BUTTON_IMPULSES()
{
responder->Activate(ipLBN_PRESS);
responder->Activate(ipLBN_RELEASE);
responder->Activate(ipRBN_PRESS);
responder->Activate(ipRBN_RELEASE);

};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::stopMOUSE_BUTTON_IMPULSES()
{
responder->Deactivate(ipLBN_PRESS);
responder->Deactivate(ipLBN_RELEASE);
responder->Deactivate(ipRBN_PRESS);
responder->Deactivate(ipRBN_RELEASE);

};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::show()
{
setfillstyle(SOLID_FILL,7);
//setcolor(15);
raisedbar(left,top,right,bottom,27);
//outtextxy(left+3,top+1,NAME);
setcolor(0);
outtextxy(left+4,top,NAME);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::show2()
{
//setcolor(27);
loweredbar(left,top,right,bottom,27);
//outtextxy(left+3,top+1,NAME);
setcolor(15);
outtextxy(left+4,top,NAME);
};
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspMOUSE_MOVE()
{//if the mouse moved and this response is currently on this object's
 //active response list a MOUSE_MOVE message should make this function run
if(pointinrect(&cMSG->pt))//if the cMSG->pt is in this RECT

  {             	  ////////////////////////////////////////
   if(MOUSE_REL == OUT)// if the pointer is out                 //
								//
     { /////////////////////////////////////////                //
      MOUSE_REL=IN;   // let this know        //                //
      MOUSE_IN=TRUE;  // make a reflex happen //                //
     };/////////////////////////////////////////                //
								//
  }else if(MOUSE_REL == IN)//if the cMSG->pt is not in this RECT//

	  { /////////////////and this don't know //
	   MOUSE_REL=OUT;  //let this know       //
	   MOUSE_OUT=TRUE; //make a reflex happen//
	  }////////////////////////////////////////

}
//////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::rfxMOUSE_IN()
{
//This Function should only be called
//when the mouse pointer moves from outside
//to inside
MOUSE_IN=0;
//QMOUSE->hide();
//show2();
//QMOUSE->show();
//MOUSE->setcursor(HAND);
startMOUSE_BUTTON_IMPULSES();
actionMOUSE_IN();
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MouseTrap::rfxMOUSE_OUT()
{
//This Function should only be called
//when the mouse pointer moves from inside
//to outside
MOUSE_OUT=0;
//QMOUSE->hide();
//show();
//QMOUSE->show();
//MOUSE->setcursor(ARROW);
stopMOUSE_BUTTON_IMPULSES();
actionMOUSE_OUT();
}
////////////////////////////////////////////////////////////////////////////

void MouseTrap::actionMOUSE_IN()
{
//MOUSE->setcursor(&HAND);
//EMPTY TO BE OVERLOADED
};

void MouseTrap::actionMOUSE_OUT()
{
//MOUSE->setcursor(&ARROW);
//EMPTY TO BE OVERLOADED
};


//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspLBN_PRESS()
{
if(pointinrect(&cMSG->pt))
  {
   LBN_PRESS_IN=1;
   //show2();
   actionLBN_PRESS_IN();
  }
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspLBN_RELEASE()
{
//stopMOUSE_BUTTON_IMPULSES();
if(pointinrect(&cMSG->pt))
  {
   if(LBN_PRESS_IN==1){
     // show();
     //POST_MESSAGE(NULL,ID,0,0,QMOUSE->pdPOINT);
      LBN_PRESS_IN=0;
      actionLBN_RELEASE_IN_LBN_PRESS_IN();
      return;
     }
   actionLBN_RELEASE_IN_LBN_PRESS_NOT_IN();
   return;
  }
 actionLBN_RELEASE_NOT_IN();//would occur after a drag drop
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspRBN_PRESS()
{
if(pointinrect(&cMSG->pt))
  {
   RBN_PRESS_IN=1;
   actionRBN_PRESS_IN();
  }
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspRBN_RELEASE()
{
//stopMOUSE_BUTTON_IMPULSES();
if(pointinrect(&cMSG->pt))
  {
   if(RBN_PRESS_IN==1){
      //POST_MESSAGE(NULL,ID,0,0,QMOUSE->pdPOINT);
      RBN_PRESS_IN=0;
      actionRBN_RELEASE_IN_RBN_PRESS_IN();
      return;
     }
     actionRBN_RELEASE_IN_RBN_PRESS_NOT_IN();
    return;
  }
 //what condition would call for knowing if there was a press in?
 actionRBN_RELEASE_NOT_IN();//would occur after a drag drop
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionLBN_PRESS_IN()
{
//textbox(400,400,"actionLBN_PRESS_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionLBN_RELEASE_IN_LBN_PRESS_IN()
{
//textbox(400,400,"actionLBN_RELEASE_IN_LBN_PRESS_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionLBN_RELEASE_IN_LBN_PRESS_NOT_IN()
{
//textbox(400,400,"actionLBN_RELEASE_IN_LBN_PRESS_NOT_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionLBN_RELEASE_NOT_IN()
{
//textbox(400,400,"actionLBN_RELEASE_NOT_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionRBN_PRESS_IN()
{
//textbox(400,400,"action_RBN_PRESS_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionRBN_RELEASE_IN_RBN_PRESS_IN()
{
//textbox(400,400,"action_RBN_RELEASE_IN_RBN_PRESS_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionRBN_RELEASE_IN_RBN_PRESS_NOT_IN()
{
//  textbox(400,400,"action_RBN_RELEASE_IN_RBN_PRESS_NOT_IN");
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::actionRBN_RELEASE_NOT_IN()
{
// textbox(400,400,"action_RBN_RELEASE_NOT_IN");
 };
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MouseTrap::rspKEY_PRESS()
{
  if((kb->AsciiChar==Escape) & (kb->Ctrl==1)) kpCtrlEscape();
  if((kb->AsciiChar==BackSpace) &
  (kb->Ctrl==1)) kpCtrlEscape();
};
//////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void MouseTrap::kpCtrlEscape()
{

};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
MouseTrap::~MouseTrap()
{
responder->Deactivate(ipLBN_PRESS);
responder->Deactivate(ipLBN_RELEASE);
responder->Deactivate(ipRBN_PRESS);
responder->Deactivate(ipRBN_RELEASE);
responder->Deactivate(ipMOUSE_MOVE);
reflexor->Deactivate(ipMOUSE_IN);
reflexor->Deactivate(ipMOUSE_OUT);
};
///////////////////////////////////////////////////////////////////////////


