//////////////////////////////////////////////////////////////////////////
class ColorBar:public MouseTrap
{
public:
 int StartColor;
  ColorBar(HMODULE hMOD,
	   int left,
	   int top,
	   unsigned int id);
  virtual void show();
  virtual void actionLBN_RELEASE_IN_LBN_PRESS_IN();
  //virtual void Respond(MSG *Msg);
  ~ColorBar();
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
ColorBar::ColorBar(HMODULE hMOD,
		   int left,
		   int top,
		   unsigned int id):MouseTrap(hMOD,
					      left,
					      top,
					      8*16+2,
					      20,
					      "ColorBar",
					       id)
{
StartColor=0;
DRAW_COLOR=15;
};
//////////////////////////////////////////////////////////////////////////

/*/////////////////////////////////////////////////////////////////////////
void ColorBar::Respond(MSG *Msg)
{
cMSG->copy(Msg);
responder->Respond(cMSG,this);
}
/*/////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
void ColorBar::show()
{
 MOUSE->hide();
 setcolor(0);
 box(left,top,right,bottom);
 for(int C=0;C<16;C++)
 {
     setfillstyle(SOLID_FILL,StartColor+C);
     bar(left+1+(C*8),top+1,left+9+(C*8),bottom-10);
  };
 MOUSE->show();
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void ColorBar::actionLBN_RELEASE_IN_LBN_PRESS_IN()
{
//textbox(400,400,"actionLBN_RELEASE_IN_LBN_PRESS_IN");
MOUSE->hide();
DRAW_COLOR=getpixel(MOUSE->pdPOINT.x,MOUSE->pdPOINT.y);
setfillstyle(SOLID_FILL,DRAW_COLOR);
bar(left+1,bottom-9,right-1,bottom-1);
MOUSE->show();
};
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
ColorBar::~ColorBar()
{
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
class PaletteConsole :public Console, public RECT
{
public:
int StartColor;
PushButton *decpb,*incpb;
impulse *ipDEC,*ipINC,*ipDECx,*ipINCx;
ColorBar *CB;
Coaster *CST;
PaletteConsole(HMODULE hMOD,int l,int t,unsigned int i);
void rspDEC();
void rspINC();
void rfxDECx();
void rfxINCx();
//virtual void Respond(MSG *Msg);
//virtual void Reflex();
virtual void show(void);
~PaletteConsole();
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
PaletteConsole::PaletteConsole(HMODULE hMOD,int l,int t,unsigned int id)
       :Console(hMOD,"PaletteConsole",id)
       ,RECT(l,t,23+8*16,20)
{
//CST=new Coaster(hMODULE,left,top,right-left,bottom-top,"Coaster",4);
//PUT_PRIMUS((NEXUS *)CST);
//CST->startMOUSE_MOVE_IMPULSES();
decpb=new PushButton(hMODULE,left,top,10,20,"<",1);
PUT_PRIMUS((NEXUS *)decpb);
decpb->startMOUSE_MOVE_IMPULSES();
incpb=new PushButton(hMODULE,right-10,top,10,20,">",2);
PUT_PRIMUS((NEXUS *)incpb);
incpb->startMOUSE_MOVE_IMPULSES();
CB=new ColorBar(hMODULE,left+10,top,3);
PUT_PRIMUS((NEXUS *)CB);
CB->startMOUSE_MOVE_IMPULSES();
//FOR_EACH((pMF)(&MouseTrap::startMOUSE_MOVE_IMPULSES));
ipDEC=responder->MAKE_RESPONSE(PaletteConsole, 1, rspDEC);
ipINC=responder->MAKE_RESPONSE(PaletteConsole, 2, rspINC);
ipDECx=reflexor->MAKE_REFLEX(PaletteConsole,&decpb->LBN_PRESS_IN, 1, rfxDECx);
ipINCx=reflexor->MAKE_REFLEX(PaletteConsole,&incpb->LBN_PRESS_IN, 1, rfxINCx);
responder->Activate(ipDEC);
responder->Activate(ipINC);
reflexor->Activate(ipDECx);
reflexor->Activate(ipINCx);
//CST->show();
};
//////////////////////////////////////////////////////////////////////////

/*/////////////////////////////////////////////////////////////////////////
void PaletteConsole::Respond(MSG *Msg)
{
Component *x;
cMSG->copy(Msg);
responder->Respond(cMSG,this);
for(x = (MouseTrap *)PRIMUS;
    x != NULL;
    x = ++(*x)) x->Respond(cMSG);
//    incpb->Respond(cMSG);
//    decpb->Respond(cMSG);
//    CB->Respond(cMSG);
}
/*/////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
void PaletteConsole::show(void)
{
FOR_EACH((pMF)(&MouseTrap::show));

};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void PaletteConsole::rspDEC()
{
//setcolor(15);
//outtextxy(10,10,"rspDEC");
if(CB->StartColor>0)
{
CB->StartColor=CB->StartColor-1;
CB->show();
};
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void PaletteConsole::rfxDECx()
{
POST_MESSAGE(hMODULE,
	 decpb->ID,
	 NULL,
	 NULL,
	 MOUSE->pdPOINT);
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void PaletteConsole::rfxINCx()
{
POST_MESSAGE(hMODULE,
	 incpb->ID,
	 NULL,
	 NULL,
	 MOUSE->pdPOINT);
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void PaletteConsole::rspINC()
{
//setcolor(15);
//outtextxy(10,20,"rspINC");
if(CB->StartColor<244)
{
CB->StartColor=CB->StartColor+1;
CB->show();
};
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
PaletteConsole::~PaletteConsole()
{
responder->Deactivate(ipDEC);
responder->Deactivate(ipINC);
reflexor->Deactivate(ipDECx);
reflexor->Deactivate(ipINCx);
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
class PaletteModule:public Module
{
public:
PaletteConsole *PC;
PaletteModule();
//void Respond(MSG *Msg);
//void Reflex();
~PaletteModule();
};
//////////////////////////////////////////////////////////////////////////

PaletteModule::PaletteModule():Module("Pallete",10200)
{

setfillstyle (SOLID_FILL,8);
bar(0,400,799,599);
PC=new PaletteConsole(hMODULE,100,100,11000);
PUT_PRIMUS((NEXUS *)PC);
PC->show();
//PC->start();
PC->active=1;
};

/*///////////////////////////////////////////////////////////////////////////
void PaletteModule::Respond(MSG *Msg)
{
PaletteConsole *x;
cMSG->copy(Msg);
//printf("IN MOD RESPOND","s");
responder->Respond(cMSG,this);
PC->Respond(cMSG);

//for(x = (PaletteConsole *)PRIMUS;
//	 x != NULL;
//	 x =(PaletteConsole *) ++(*x)) x->Respond(cMSG);


};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void PaletteModule::Reflex()
{
PaletteConsole *x;
for(x=(PaletteConsole *)PRIMUS;
	 x!=NULL;
	 x=(PaletteConsole *)++(*x))x->reflexor->Reflex(x);
};
/*////////////////////////////////////////////////////////////////////////////


PaletteModule::~PaletteModule()
{
};
