//////////////////////////////////////////////////////////////////////
//INCLUDES and DEFINES////////////////////////////////////////////////
#include<conio.h>
#include<stdio.h>
#include<stdlib.h>
#include<bios.h>
#include<dos.h>
#include<alloc.h>
#include<string.h>
//#include<iostream.h>

#include"d:\tc\project\geometry\point.h"
#include"d:\tc\project\geometry\rect.h"

#include"d:\tc\project\core\xstring.h"
#include"d:\tc\project\core\objects.h"
#include"d:\tc\project\core\message.h"

#include"d:\tc\project\nexus\nexus.h"
#include"d:\tc\project\nexus\impulse.h"

#include"d:\tc\project\core\msgqueue.h"
#include"d:\tc\project\core\componen.h"
#include"d:\tc\project\core\console.h"
#include"d:\tc\project\core\module.h"
#include"d:\tc\project\core\modulatr.h"

#include"d:\tc\project\devices\keyboard\keyboard.h"
#include"d:\tc\project\devices\mouse\mouse.h"

//#include"d:\tc\project\txi\txcomp.h"
//#include"d:\tc\project\txi\txcons.h"
//#include"d:\tc\project\txi\txmod.h"
//#include"d:\tc\project\txi\infonent.h"

//#include"d:\tc\project\devices\mouse\mtxcon.h"
//#include"d:\tc\project\devices\keyboard\ktxc.h"

#include<graphics.h>
#include"D:\TC\INCLUDE\svgautil.h"
#include"D:\TC\INCLUDE\svga256.h"
#include"d:\tc\project\devices\display\grafix.h"
#include"d:\tc\project\devices\display\svga.h"

#include"d:\tc\project\gxi\mousetrp.h"

#define stPROCESS_ACTION 1
#define stPROCESS_MESSAGE 2
#define stEXIT 3
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
//VARIABLES///////////////////////////////////////////////////////

int done;
int status;
int pressed,oldx,oldy;
Modulator *DEVICE_MODULATOR;
//TxModule *MOUSEMOD;
//TxModule *KEYBOARDMOD;
//Menu *SystemMenu;
//MouseTxConsole *MTXC;
//KeyboardTxConsole *KTXC;
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//FUNCTION PROTOTYPES////////////////////////////////////////////////
void main();
void init();
int process_action();
int process_message();
void Exit();
////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//MAIN FUNCTION DEFINITION///////////////////////////////////////////
void main()
{
 init();
 done=0;
 status=stPROCESS_ACTION;
 while(done==0)
      {
       if(status==stPROCESS_ACTION)status=process_action();
       if(status==stPROCESS_MESSAGE)status=process_message();
       if(status==stEXIT)Exit();
      };
};
///////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//init FUNCTION DEFINITION///////////////////////////////////
void init()
{
//directvideo=1;
//clrscr();
initgrafix();
 outtextxy(0,0,"grafix going");
//window(1,1,80,25);

oldmsg=new MSG();
MSG_Q=new MSG_QUEUE();
DEVICE_MODULATOR=new Modulator("DEVICE_MODULATOR",1);
kb=new KEY_DEVICE();
MOUSE=new POINTING_DEVICE();
//MOUSEMOD=new TxModule("Mouse Info",9000,10,10,25,9);
//MOUSEMOD->setForegroundColor(BLACK);
//MOUSEMOD->setBackgroundColor(CYAN);

//MTXC=new MouseTxConsole("MTXconsole ",9003,11,11,28,8);
//MOUSEMOD->PUT_PRIMUS((NEXUS *)(MTXC));


SystemMenu=new Menu("ENGINE Main Menu",400,100,100);

SystemMenu->AddItem("Palette",9);
SystemMenu->AddItem("Open",10);
SystemMenu->AddItem("Save",11);
SystemMenu->AddItem("Read Sector",12);
SystemMenu->AddItem("Format A:",13);


//KEYBOARDMOD=new TxModule("Keyboard Info",9002,40,10,25,9);
//KEYBOARDMOD->setForegroundColor(BLACK);
//KEYBOARDMOD->setBackgroundColor(LIGHTGRAY);

//KTXC=new KeyboardTxConsole("KTXconsole ",9003,41,11,28,8);
//KEYBOARDMOD->PUT_PRIMUS((NEXUS *)(KTXC));


DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)kb);
DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)MOUSE);
//DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)MOUSEMOD);

//DEVICE_MODULATOR->PUT_MAXIMUS((NEXUS *)KEYBOARDMOD);

MOUSE->active=1;
kb->active=1;
//MOUSEMOD->active=1;
//SystemMenu->active=1;
//SystemMenu->show();
MOUSE->install();
MOUSE->show();
//MOUSEMOD->show();
//KEYBOARDMOD->show();


};
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//process_action FUNCTION DEFINITION///////////////////////////
int process_action()
{
 hasoldmessage=0;
 //save the head message
 //at this point the head message should be processed
 //if messages occur they are pushed onto the tail

 if(MSG_Q->PRIMUS!=NULL)
 {
    oldmsg->copy(MSG_Q->GET_PRIMUS_MESSAGE());
    MSG_Q->DELETE_MESSAGE((MSG_NODE *)MSG_Q->PRIMUS);
    hasoldmessage=1;
   };

 //reset the key
 /*/
 key=0;
 //if a key is pressed get the key and post a message with the key
 if(bioskey(1)!=0)
	{
	 kb.KeyPressed=1;
	 kb.getkey();
	 POST_MESSAGE(NULL,
		 KEY_PRESS,
		 kb.ScanCode,
		 kb.AsciiChar,
		 NULL_POINT);
	};
 /*/
 //process object natures
 // portal_q->REFLEX();
 DEVICE_MODULATOR->Reflex();
 SystemMenu->Reflex();
 MOUSE->mousehandler();
 //if the message que is empty reapeat this function
  if(MSG_Q->PRIMUS==NULL)return(stPROCESS_ACTION);
 //if the message que is not empty process the message

 return(stPROCESS_MESSAGE);
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//process_message FUNCTION DEFINITION////////////////////////////////
int process_message()
{

 DEVICE_MODULATOR->Respond(MSG_Q->GET_PRIMUS_MESSAGE());
 SystemMenu->Respond(MSG_Q->GET_PRIMUS_MESSAGE());
 //////////////////////////////////////////////////////////////////////////
 if((((MSG_Q->GET_PRIMUS_MESSAGE())->message==KEY_PRESS)&
	 (kb->AsciiChar==Escape)&
	  (kb->Ctrl==1)))
	  {
	  return(stEXIT);
	  };

 if((MSG_Q->GET_PRIMUS_MESSAGE())->message==KEY_PRESS)
     {
    // gotoxy(1,1);
    //cout<<kb->AsciiChar<<"                            ";
	  };

///////////////////////////////////////////////////////////////////////////

 if((MSG_Q->GET_PRIMUS_MESSAGE())->message==RBN_PRESS)
   {
    SystemMenu->start();
   };

//////////////////////////////////////////////////////////////////////////
 return(stPROCESS_ACTION);
}
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////

//Exit FUNCTION DEFINITION///////////////////////////////////////////////
void Exit()
{
MOUSE->install();
MOUSE->hide();
//DEVICE_MODULATOR->EXTRACT_NEXUS((NEXUS *)&MOUSE);
if(oldmsg!=NULL)delete oldmsg;
if(MSG_Q!=NULL)delete MSG_Q;
if(DEVICE_MODULATOR!=NULL)delete DEVICE_MODULATOR;
if(SystemMenu!=NULL)delete SystemMenu;
 done=1;
// closegraph();
};
/////////////////////////////////////////////////////////////////////////