//////////////////////////////////////////////////////////////////////////
class TxModule :public Module, public RECT
{
public:
int ForegroundColor,BackgroundColor;
TxModule(char *n,unsigned int i,int l,int t,int sx,int sy);
void setForegroundColor(int c);
void setBackgroundColor(int c);
virtual void show(void);
~TxModule();
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
TxModule::TxModule(char *n,unsigned int i,int l,int t,int sx,int sy)
       :Module(n,i)
       ,RECT(l,t,sx,sy)
{
};

//////////////////////////////////////////////////////////////////////////
void TxModule::setForegroundColor(int c)
{
ForegroundColor=c;
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void TxModule::setBackgroundColor(int c)
{
BackgroundColor=c;
};
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
void TxModule::show(void)
{
textbackground(BackgroundColor);
textcolor(ForegroundColor);
int x,y;

//left top border 
gotoxy(left,top);
cprintf(" ");//218 

//right top border 
gotoxy(right,top);
cprintf(" ");//191  

//left bottom border 
gotoxy(left,bottom);
cprintf(" ");//92;//

//right bottom border 
gotoxy(right,bottom);
cprintf(" ");//217;//

//top border
y=top;
for(x=left+1;x<right;x++)
{
 gotoxy(x,y);
 cprintf(" ");//196;//
};

//bottom border
y=bottom;
for(x=left+1;x<right;x++)
{
 gotoxy(x,y);
 cprintf(" ");//196;//
};

//left border
x=left;
for (y=top+1;y<bottom;y++)
{
 gotoxy(x,y);
 cprintf(" ");//179;//
};

//right border
x=right;
for (y=top+1;y<bottom;y++)
{
 gotoxy(x,y);
 cprintf(" ");//179;//
};

gotoxy(left+2,top);
cprintf(NAME);

gotoxy(right-4,top);
cprintf("[X]");
gotoxy(right-7,top);
cprintf("[-]");
/*/left top border 
gotoxy(left,top);
cprintf("");//218 

//right top border 
gotoxy(right,top);
cprintf("");//191  

//left bottom border 
gotoxy(left,bottom);
cprintf("");//92;//

//right bottom border 
gotoxy(right,bottom);
cprintf("");//217;//

//top border
y=top;
for(x=left+1;x<right;x++)
{
 gotoxy(x,y);
 cprintf("");//196;//
};

//bottom border
y=bottom;
for(x=left+1;x<right;x++)
{
 gotoxy(x,y);
 cprintf("");//196;//
};

//left border
x=left;
for (y=top+1;y<bottom;y++)
{
 gotoxy(x,y);
 cprintf("");//179;//
};

//right border
x=right;
for (y=top+1;y<bottom;y++)
{
 gotoxy(x,y);
 cprintf("");//179;//
};
/*/
FOR_EACH((pMF)(&TxConsole::show));
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
TxModule::~TxModule()
{
};
//////////////////////////////////////////////////////////////////////////
/*/

Example Modules


ڴTxModule 1.00    [][][X]ÿ

  
  
  
  
  
  
  
  

                          

Example Task Bar with Buttons and Clock

Start <Program1> Program2 Program3    | 12:30 AM


  TxModule 1.00    [][][X]  
  
  
  
  
  
  
  
  
  
  
                              




Ŀ
۳ TxModule 1.01    [][][X]
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳





Ŀ
۳ Program1                [X]
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳
۳۳



///////////////////////////////////////////////////////////////////////
/*/