//int78h.h
#define MODULE_INTR 0x78
#define MODULATION_SERVICES_PRESENT 0
#define MODULE_JOIN 1

//GENERAL DATA AND ADDRESS REGISTERS
unsigned long PARAM_EAX;//primary accumulator
unsigned long PARAM_EBX;//base (address) register
unsigned long PARAM_ECX;//count register
unsigned long PARAM_EDX;//data register
unsigned long PARAM_ESI;//source index register
unsigned long PARAM_EDI;//destination index register
unsigned long PARAM_EBP;//base pointer
unsigned long PARAM_ESP;//stack pointer

//SEGMENT SELECTOR REGISTERS
unsigned int PARAM_CS;//code selector
unsigned int PARAM_SS;//stack selector
unsigned int PARAM_DS;//data selector
unsigned int PARAM_ES;//extra selector
unsigned int PARAM_FS;//foo selector
unsigned int PARAM_GS;//goo selector



void interrupt ( *old_78h_handler)(__CPPARGS);
void interrupt int_78h_handler(__CPPARGS);

void interrupt int_78h_handler(__CPPARGS)
{
asm{

	 mov PARAM_EAX,eax;
	 mov PARAM_EBX,ebx;
	 mov PARAM_ECX,ecx;
	 mov PARAM_EDX,edx;
	 mov PARAM_ESI,esi;
	 mov PARAM_EDI,edi;
	 mov PARAM_EBP,ebp;
	 mov PARAM_ESP,esp;

	};

	 if(PARAM_EAX==1)

};

main(void)
{
old_78h_handler = getvect(MODULE_INTR);
	/* install the new interrupt handler */
setvect(MODULE_INTR, int_78h_handler);
keep(0, (_SS + (_SP/16) - _psp));
};