////////////////////////////////////////////////////////////////////////////
class Console : public ROTI,public RECT
{
public:
unsigned int ID;
char *NAME;
unsigned int active;

Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_Q *MSGQ;
Console(char *n);
Console(char *n);
void initialize(char *n);
virtual void start();
virtual void stop();
virtual void AddComponent(char *text,
		  unsigned int id);
void AddComponent_primus(unsigned int id);
void add_before_Component(unsigned int id,unsigned int o);
void add_after_Component(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
~Console();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console::Console(char *n):ROTI()
{
responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Console,RBN_RELEASE,start);
iStop=responder->MAKE_RESPONSE(Console,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
active=0;
};
///////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////
Console::Console(char *n):ROTI()
{
initialize(n);
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::initialize(char *n)
{

responder=new Coordinator();
//iStart=responder->MAKE_RESPONSE(Console,RBN_RELEASE,start);
iStop=responder->MAKE_RESPONSE(Console,LBN_RELEASE,stop);
//responder->Deactivate(iStart);
responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
active=0;
};
///////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////
void Console::start()
{

Component *j;
if(active==0)
{

for(j=(Component *)PRIMUS;
	    j!=NULL;
	    j=++(*j))
 {

 };

responder->Activate(iStop);
//responder->Deactivate(iStart);
active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void Console::stop()
{
if(active==1)
{
responder->Deactivate(iStop);
//responder->Activate(iStart);

 active=0;
};
}
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
void Console::AddComponent(char *text,
		   unsigned int id)
{
 Component *i;
 i=new Component(text,id);
 PUT_MAXIMUS((NEXUS *)i);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::Respond(MSG *Msg)
{
Component *x;
cMSG->copy(Msg);
responder->Respond(cMSG,this);
for(x = (Component *)PRIMUS;
    x != NULL;
    x = ++(*x)) x->Respond(cMSG);
};
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void Console::Reflex()
{
Component *x;
for(x=(Component *)PRIMUS;
    x!=NULL;
    x=++(*x))x->reflexor->Reflex(x);
};
/////////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
void Console::add_before_Component(unsigned int id,unsigned int o)
{
 Component *i,*j;
 i=new Component(id);
 for(j=(Component *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Console::add_after_Component(unsigned int id,unsigned int o)
{
 Component *i,*j;
 i=new Component(id);
 for(j=(Component *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console::~Console()
{
//responder->Deactivate(iStart);
responder->Deactivate(iStop);

if(responder!=NULL)delete responder;
if(background!=NULL)delete (background);
if(name!=NULL)delete (name);
if(PRIMUS!=NULL)
 {
  Component* NEXT;
  Component* current = (Component *)PRIMUS;
  for(;;)
     {
      NEXT=(Component *)current->next;
      if(current!=NULL)delete current;
      if(NEXT == NULL)break;
      current=NEXT;
     };
  };
};
////////////////////////////////////////////////////////////////////////////
