#include <io.h>
#include<fcntl.h>

class font
{
public:

char *fname;
char far *image;
unsigned int fileID;//offset0
unsigned char fmode;//offset2
unsigned char  charheight;//offset3

font(char *fn);
void fload(void);
void set(void);
~font();
};

font::font(char *fn)
{
fname=new char[strlen(fn)];
strcpy(fname,fn);
};

void font::fload(void)
{
  int handle,bytes;
 long size;
 handle = open(fname,O_RDONLY);
 // get the size of the file //
 size= filelength(handle);
 //cout<<" SIZE " <<size;
 //allocate space for the pointer with full size
 image=new char[size+1];
 if(image!=NULL)
 {
  if(bytes=read(handle,(char *)image, size)== -1)
    {
     close(handle);
    // outtextxy(70,169,"disk read error");
    //cout<<"DISK ERROR";
     //return(NULL);
    }
  else
    {
     // close the file //
     close(handle);
    // return(image);
    };
  }
 else
   {
   //cout<<"MEMORY ALLOCATION ERROR";
     //outtextxy(70,169,"memory allocation error");
     //return(NULL);
   };
 fileID=(unsigned int)(*(image +0));
 fmode=(unsigned char)(*(image +2));
 charheight=(unsigned char)(*(image+3));
};

void font::set(void)
{
unsigned mh_off,mh_seg;
mh_seg=FP_SEG(image);
mh_off=FP_OFF(image);
asm{
mov ah,05h;
mov al,0;
int 10h;

mov ah,00;
mov al,12h;
int 10h;


mov es,mh_seg;
mov bp,mh_off;
mov ah,11h;
mov al,21h;
//mov bh,16;//bytes per character
mov bl,2;//?row specifier
mov cx,16;// number of bytes per character
//mov dl,30;//rows
int 10h;
};
};

void font::~font()
{
if (fname!=NULL)delete fname;
if (image!=NULL)delete image;
};


