////////////////////////////////////////////////////////////////////////
class RECT
{
 public:
 int left,top,right,bottom;
 RECT(int l,int t,int sx,int sy);
 void setpoints(int l,int t,int r,int b);
 virtual void move(int deltax,int deltay);
 RECT copy(RECT *rect);
 int pointinrect(POINT *p);
 RECT(){;}
};
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
RECT::RECT(int l,int t,int sx,int sy)
          {left=l;top=t;right=left+sx-1;bottom=top+sy-1;};
void RECT::setpoints(int l,int t,int r,int b){left=l;top=t;right=r,bottom=b;};
inline int RECT::pointinrect(POINT *p)
{
  //only works for   0
  //               0  +
  //                 +
  if((p->x < right) && (p->x > left)&&
     (p->y < bottom) && (p->y > top)){return(1);}else {return(0);};
};
////////////////////////////////////////////////////////////////////////

inline RECT RECT::copy(RECT *rect)
{
 RECT rRECT;
 rRECT.left=rect->left;
 rRECT.top=rect->top;
 rRECT.right=rect->right;
 rRECT.bottom=rect->bottom;
return(rRECT);
};
////////////////////////////////////////////////////////////////////////
void RECT::move(int deltax,int deltay)
{
   left=left+deltax;
   right=right+deltax;
   top=top+deltay;
   bottom=bottom+deltay;
};
////////////////////////////////////////////////////////////////////////
