////////////////////////////////////////////////////////////////////////////
//#include<iostream.h>
//#include<string.h>
//#include<impulse.h>
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
class MenuItem:  public  Component,public RECT
{
public:
unsigned int MOUSEIN,MOUSEOUT,MOUSEREL,PRESSIN;
impulse *iCheckPress,*iCheckRelease,*iCheckMove,*iMouseIn,*iMouseOut;
MSG *cMSG;
MenuItem(char *text,
	 unsigned int id,
	 int left,
	 int top,
	 int sizex,
	 int sizey);
MenuItem *operator ++(){return ((MenuItem *)next);};
MenuItem *operator --(){return ((MenuItem *)previous);};
void start();
void stop();
void show();
void show2();
void show3();
void MOUSE_IN();
void MOUSE_OUT();
void checkpress();
void checkrelease();
void checkmove();

~MenuItem();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
class Menu : public Console,public RECT
{
public:
char *name;
char far *background;
unsigned long backgroundsize,active;
int pixelwidth;
Coordinator *responder;
impulse *iStart,*iStop;
MSG *cMSG;
Menu(char *n,
     unsigned int id,
     int x,
     int y);
void start();
void stop();
void save_background();
void restore_background();
void AddItem(char *text,
	     unsigned int id);
void AddItem_primus(unsigned int id);
void add_before_MenuItem(unsigned int id,unsigned int o);
void add_after_MenuItem(unsigned int id,unsigned int o);

void show();
void hide();
~Menu();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
MenuItem::MenuItem(char *text,
		   unsigned int id,
		   int left,
		   int top,
		   int sizex,
		   int sizey):Component(text,id),
				   RECT(left,top,sizex,sizey)
{
 PRESSIN=0;
 MOUSEIN=0;
 MOUSEOUT=0;
 MOUSEREL=0;
 iCheckMove=responder->MAKE_RESPONSE(MenuItem, MOUSE_MOVE, checkmove);
 iCheckPress=responder->MAKE_RESPONSE(MenuItem, LBN_PRESS, checkpress);
 iCheckRelease=responder->MAKE_RESPONSE(MenuItem, LBN_RELEASE, checkrelease);
 iMouseIn=reflexor->MAKE_REFLEX(MenuItem, &MOUSEIN, 1, MOUSE_IN);
 iMouseOut=reflexor->MAKE_REFLEX(MenuItem, &MOUSEOUT, 1, MOUSE_OUT);
 responder->Deactivate(iCheckPress);
 responder->Deactivate(iCheckRelease);
 stop();
 cMSG=new MSG();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MenuItem::start()
{
 responder->Activate(iCheckMove);
 reflexor->Activate(iMouseIn);
 reflexor->Activate(iMouseOut);
};
void MenuItem::stop()
{
 responder->Deactivate(iCheckMove);
 reflexor->Deactivate(iMouseIn);
 reflexor->Deactivate(iMouseOut);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MenuItem::show()
{
setfillstyle(SOLID_FILL,7);
//setcolor(15);
bar(left-1,top+2,right+1,bottom);
//outtextxy(left+3,top+1,TEXT);
setcolor(0);
outtextxy(left+4,top,NAME);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MenuItem::show2()
{
//setcolor(27);
loweredbar(left,top+2,right,bottom,27);
//outtextxy(left+3,top+1,TEXT);
setcolor(15);
outtextxy(left+4,top,NAME);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MenuItem::show3()
{
//setcolor(27);
loweredbar(left,top+2,right,bottom,27);
//outtextxy(left+3,top+1,TEXT);
setcolor(12);
outtextxy(left+4,top,NAME);
};
////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
void MenuItem::MOUSE_IN()
{
MOUSEIN=0;
MOUSE->hide();
if(MOUSE->L_BUTTON==1)show3();
else show2();
MOUSE->show();
responder->Activate(iCheckPress);
responder->Activate(iCheckRelease);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void MenuItem::MOUSE_OUT()
{
MOUSEOUT=0;
MOUSE->hide();
show();
MOUSE->show();
responder->Deactivate(iCheckPress);
responder->Deactivate(iCheckRelease);
};

////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MenuItem::checkmove()
{
if(pointinrect(&cMSG->pt))
  {
   if(MOUSEREL==0){MOUSEREL=1;MOUSEIN=1;};
  }else if(MOUSEREL==1){MOUSEREL=0;MOUSEOUT=1;}
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MenuItem::checkpress()
{
if(pointinrect(&cMSG->pt))
  {
     MOUSE->hide();
     show3();
     MOUSE->show();
   //if(MOUSEREL==0){MOUSEREL=1;MOUSEIN=1;};
   //textbox(right+2,bottom,"Press in " ,ID);
   PRESSIN=1;
  }//else if(MOUSEREL==1){MOUSEREL=0;MOUSEOUT=1;}
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void MenuItem::checkrelease()
{
responder->Deactivate(iCheckPress);
responder->Deactivate(iCheckRelease);
if(pointinrect(&cMSG->pt))
  {
  // if(PRESSIN==1){
  // POST_MESSAGE(NULL,ID,0,0,MOUSE->pdPOINT);
  // PRESSIN=0;
   //};
   POST_MESSAGE(NULL,ID,0,0,MOUSE->pdPOINT);
   //if(MOUSEREL==0){MOUSEREL=1;MOUSEIN=1;};
   //textbox(right+2,bottom,"Release in " ,ID);
  }//else if(MOUSEREL==1){MOUSEREL=0;MOUSEOUT=1;}
}
//////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
MenuItem::~MenuItem()
{
responder->Deactivate(iCheckPress);
responder->Deactivate(iCheckRelease);
responder->Deactivate(iCheckMove);
reflexor->Deactivate(iMouseIn);
reflexor->Deactivate(iMouseOut);
if(cMSG!=NULL)delete cMSG;
if(reflexor!=NULL)delete reflexor;
if(responder!=NULL)delete responder;
};
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
Menu::Menu(char *n,unsigned int id,int x,int y):Console(n,id),RECT(x,y,
					    strlen(n)*textwidth("W"),3)
{
backgroundsize=imsize(right-left,top-bottom);
background=new char far[backgroundsize];
pixelwidth=0;
active=0;
iStart=responder->MAKE_RESPONSE(Menu,RBN_RELEASE,start);
iStop=responder->MAKE_RESPONSE(Menu,LBN_RELEASE,stop);
responder->Deactivate(iStart);
responder->Deactivate(iStop);
//RECT(x,y,strlen(n)*textwidth("W"),1);
cMSG=new MSG();
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void Menu::start()
{
int sx,sy,c,x,y;
MenuItem *j;
if(active==0)
{
 c=0;
 sx=right-left;
 sy=bottom-top;
 setpoints(MOUSE->pdPOINT.x,
	   MOUSE->pdPOINT.y,
	   MOUSE->pdPOINT.x+sx,
	   MOUSE->pdPOINT.y+sy);
 for(j=(MenuItem *)PRIMUS;
     j!=NULL;
     j=++(*j)){
	       x=left+2;
	       y=top+(c*(textheight("W")+3));
	       j->setpoints(x,y,
			    x+pixelwidth,
			    y+textheight("W")+4);
	       c++;
	      };
 show();
 FOR_EACH((pMF)(&MenuItem::start));
 responder->Activate(iStop);
 responder->Deactivate(iStart);
 active=1;
};
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void Menu::stop()
{
if(active==1)
{
 responder->Deactivate(iStop);
 responder->Activate(iStart);
 FOR_EACH((pMF)(&MenuItem::stop));
 hide();
 active=0;
};
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void Menu::save_background()
{
 getimage(left,top,right,bottom,background);
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void Menu::restore_background()
{
  putimage(left,top,background,COPY_PUT);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Menu::AddItem(char *text,
		   unsigned int id)
{
 int x,y,sx,sy,c;
 MenuItem *i,*j;
 c=0;
 for(j=(MenuItem *)PRIMUS;
	      j!=NULL;
	      j=++(*j))c++;
 x=left+2;y=top+(c*(textheight("W")+3));
 sx=textwidth(text)+8;
 if(sx>pixelwidth)
   {
    pixelwidth=sx;
    for(j=(MenuItem *)PRIMUS;
	j!=NULL;
	j=(MenuItem *)j->next)j->right=j->left+pixelwidth;
   }
 sx=pixelwidth;
 right=left+pixelwidth+4;
 sy=textheight("W")+4;
 i=new MenuItem(text,id,x,y,sx,sy);
 PUT_MAXIMUS((NEXUS *)i);
 bottom=(bottom)+(textheight("W")+3);
 backgroundsize=imsize(right-left,top-bottom);
 if(background!=NULL)delete background;
 backgroundsize=imsize(right-left,top-bottom);
 background=new char far[backgroundsize];
};
////////////////////////////////////////////////////////////////////////////



/*///////////////////////////////////////////////////////////////////////////
void Menu::add_before_MenuItem(unsigned int id,unsigned int o)
{
 MenuItem *i,*j;
 i=new MenuItem(id);
 for(j=(MenuItem *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Menu::add_after_MenuItem(unsigned int id,unsigned int o)
{
 MenuItem *i,*j;
 i=new MenuItem(id);
 for(j=(MenuItem *)PRIMUS;\
	      j->ID!=o;\
	      j=++(*j))
 {
 if(j==NULL)break;
 };
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
};
/*////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Menu::show()
{
MOUSE->hide();
save_background();
raisedbar(left,top,right,bottom,7);
FOR_EACH((pMF)(&MenuItem::show));
MOUSE->show();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void Menu::hide()
{   MOUSE->hide();
restore_background();
MOUSE->show();
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Menu::~Menu()
{
responder->Deactivate(iStart);
responder->Deactivate(iStop);
if(cMSG!=NULL)delete cMSG;
if(background!=NULL)delete (background);
if(PRIMUS!=NULL)
 {
  MenuItem* NEXT;
  MenuItem* current = (MenuItem *)PRIMUS;
  for(;;)
     {
      NEXT=(MenuItem *)current->next;
      if(current!=NULL)delete current;
      if(NEXT == NULL)break;
      current=NEXT;
     };
  };
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
/*/menumain()
{
Menu *mnu;
MenuItem *x;

mnu=new Menu(100,100,"List with 4 NEXUS");

mnu->AddItem("Item 1",1);
mnu->AddItem("Item 2",2);
mnu->AddItem("Item 3",3);
mnu->AddItem("Item 4",4);

mnu->show();


if(mnu!=NULL)delete mnu;
};
/*///////////////////////////////////////////////////////////////////////////