#include<string.h>
///////////////////////////////////////////////////////////////////
class button{
public:
int left,top,right,bottom;
char *cpFace;
char filename[32];
int message;
bitmap bmp;
void init(char fname[32],int msg);
void ffree(void);
void draw(int x,int y);
void make(char filename[32]);
void edit(void);
void save(void);

};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
class toolbar{
public:
char *background;
int left,top,right,bottom,buttons,currentbutton,bkgsize,active;
button tbutton[16];
void init(int l,int t,int btns);
void ffree(void);
void insertbutton(char fname[32],int msg,int position);
void draw(void);
int check(int msg,toolbar *pCurrenttoolbar);
int getbutton(void);
void drag();
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
void button::init(char fname[32],int msg)
{
strcpy(filename,fname);
message=msg;
cpFace=(char *)malloc(148);
cpFace=(char *)bmp.load(fname);
putimage(100,100,cpFace,0);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
void button::ffree(void)
{
if(cpFace!=NULL)free(cpFace);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void button::draw(int x,int y)
{
putimage(x,y,cpFace,0);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void button::make(char filename[32])
{
init(filename,1);
setcolor(7);
bar(100,100,115,115);
//m.read();

while (m.r_button==0)
      {
       //m.read();
       setcolor(15);
       box(0,0,319,199);
       box(0,0,319,199);

       if(m.l_button==1)
	 {
	 m.hide();
	 putpixel(m.mx,m.my,0);
	 m.show();
	 };
       };
m.hide();
getimage(100,100,115,115,cpFace);
m.show();
bmp.save(filename,cpFace,1);
cpFace=(char *)bmp.load(filename);
putimage(100,100,cpFace,0);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void button::edit(void)
{
draw(100,100);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void button::save(void)
{
char *bface;
bface=(char *)malloc(260);
getimage(100,100,115,115,bface);
bmp.save(filename,bface,1);
cpFace=(char *)bmp.load(filename);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void toolbar::init(int l,int t,int btns)
{
active=0;
left=l;
top=t;
buttons=btns;
right=l+4+buttons*17;
bottom=t+23;
currentbutton=0;
bkgsize=imagesize(left,top,right,bottom);
background=(char *)malloc(bkgsize);
getimage(left,top,right,bottom,background);
};
///////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////
void toolbar::ffree(void)
{
int index;
for (index=0;index<buttons;index++)
 {
  tbutton[index].ffree();
 };
 if(background!=NULL)free(background);
};
///////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////
void toolbar::insertbutton(char fname[32],int msg,int position)
{
tbutton[position].init(fname,msg);
tbutton[position].left=left+3+(position*17);
tbutton[position].right=tbutton[position].left+16;
};


void toolbar::draw(void)
{
int index;
setcolor(0);
bar(left,top,right,bottom);
setcolor(8);
box(left,top,right,bottom);
setcolor(7);
box(left+1,top+1,right-1,bottom-1);

for (index=0; index < buttons; index++)
   {
    //putimage(left+3+(index * 17),top+3,tbutton[index].cpFace);
     putimage(tbutton[index].left,top+3,tbutton[index].cpFace,0);
   };
   if (active==1)
    {
      setcolor(15);
      box(currentbutton*17+2+left,top+2,currentbutton*17+19+left,top+21);
    };
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
int toolbar::check(int msg,toolbar *pCurrenttoolbar)
{
int index;
//check for mouse press in toolbar
if(((m.l_button==1)&&(m.my>top)&&(m.my<bottom)&&(m.mx<right)&&(m.mx>left)))
{
   m.hide();
   pCurrenttoolbar->active=0;
   pCurrenttoolbar->draw();
   m.show();
   //wait for release
while (m.l_button!=0)
   {
     m.read();
   };

for (index = 0; index<buttons; index++)
  {
   if((m.mx<tbutton[index].right)&&(m.mx>tbutton[index].left))
      {
       if(m.my>top)
	 {
	  currentbutton=index;
	    m.hide();
	    pCurrenttoolbar=this;
	    pCurrenttoolbar->active=1;
	    pCurrenttoolbar->draw();
	    m.show();
	  return(tbutton[index].message);

	 };
       index=buttons;
      };
   };
};
  return(msg);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
int toolbar::getbutton(void)
{
return(currentbutton);
};




void toolbar::drag()
 {
       int xx,yy,index;
       int oldx,oldy,dx,sx,sy;

       m.read();
       xx=left;yy=m.my;
       dx=(m.mx)-left;
       sx=right-left;
       sy=bottom-top;
    if (m.l_button==1)
      {



       m.hide();

       m.show();
	 while (m.l_button == 1)
	      {

		//m.read();
		xx=(m.mx)-dx;
		yy=m.my;
		oldx=(m.old_x)-dx;
		oldy=m.old_y;
		m.hide();
		setwritemode(XOR_PUT);
		box(xx,yy,xx+sx,yy+sy);//
		 setcolor(15);
		 box(0,0,639,479);
		 box(0,0,639,479);
		 box(0,0,639,479);
		 box(0,0,639,479);
		box(xx,yy,xx+sx,yy+sy);//
		m.show();

	      };
	  m.hide();
	       setwritemode(COPY_PUT);
	       dx=xx-left;
	  for (index=0; index < buttons; index++)
   {
	 tbutton[index].left=tbutton[index].left+dx;
	 tbutton[index].right=tbutton[index].right+dx;
	 tbutton[index].top=top+3;
	 tbutton[index].bottom=bottom-3;
   };
       //restore the old background
       putimage(left,top,background,0);

       //set new coordinates
       left=xx;right=xx+sx;top=yy;bottom=yy+sy;

       //get new background
       getimage(left,top,right,bottom,background);

       //draw toolbar at new location
       draw();

	  //show the mouse
	  m.show();

	  };
	  };



/* mybutton.make("c:\\vga256\\point.bmp");
 mybutton.draw(10,100);
 mybutton.make("c:\\vga256\\line.bmp");
 mybutton.draw(27,100);
 mybutton.make("c:\\vga256\\box.bmp");
 mybutton.draw(44,100);
 mybutton.make("c:\\vga256\\bar.bmp");
 mybutton.draw(61,100);
 mybutton.make("c:\\vga256\\fireworks.bmp");
 mybutton.draw(78,100);
 mybutton.make("c:\\vga256\\frac.bmp");
 mybutton.draw(95,100);
 mybutton.make("c:\\vga256\\zoom.bmp");
 mybutton.draw(112,100);*/