////////////////////////////////////////////////////////////////////////////
//#include<alloc.h> 
#include<iostream.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include"c:\programs\osos\nexus\nexus.h"
#include"c:\programs\osos\core\objects.h"
#include"c:\programs\osos\geometry\point.h"
#include"c:\programs\osos\core\message.h"
#include"c:\programs\osos\nexus\impulse.h"
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
class number:  public  NEXUS
{
public:
unsigned int num;
impulse *i2;
impulse *i1;
Coordinator *nc;
number(unsigned int n);
number *operator ++(){return ((number *)next);};
number *operator --(){return ((number *)previous);};
void show();
void show2();
~number();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
number::number(unsigned int n):NEXUS()
{
 num=n;
 nc=new Coordinator();
 //nc->MakeIdle();
 i1=nc->MAKE_REFLEX(number, &num, n, show);
 i2=nc->MAKE_REFLEX(number, &num, n, show2);
 nc->Deactivate(i1);
 nc->Activate(i2);

}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void number::show()
{
 if(IS_PRIMUS())printf("PRIMUS\t");
 if(IS_MAXIMUS())printf("MAXIMUS\t");
 if(IS_INTERNEXUS())printf("INTERNEXUS\t");
 if(IS_UNUSNEXUS())printf("UNUSNEXUS\t");
//cout<<"previous:"<<previous<<"\t";
//cout<<"this:"<<this<<"\t";
//cout<<"next:"<<next<<"\n";
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void number::show2()
{
 if(IS_PRIMUS())printf("PRIMUS ");
 if(IS_MAXIMUS())printf("MAXIMUS ");
 if(IS_INTERNEXUS())printf("INTERNEXUS ");
 if(IS_UNUSNEXUS())printf("UNUSNEXUS ");
 printf("\n");
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
number::~number()
{
printf("IN number Destructor\n");
//nc->DeleteIdle();
//if(i1!=NULL)delete i1;
//if(i2!=NULL)delete i2;
if(nc!=NULL)delete nc;
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
class numberlist : public ROTI
{
public:
char *name;
numberlist(char *n);
void add_number(unsigned int n);
void add_number_primus(unsigned int n);
void add_before_number(unsigned int n,unsigned int o);
void add_after_number(unsigned int n,unsigned int o);
void show();
~numberlist();
};
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
numberlist::numberlist(char *n):ROTI()
{
name=new char[strlen(n)];
strcpy(name,n);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void numberlist::add_number(unsigned int n)
{
 number *i;
 i=new number(n);
 PUT_PRIMUS((NEXUS *)i);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void numberlist::add_before_number(unsigned int n,unsigned int o)
{
 number *i,*j;
 i=new number(n);
 for(j=(number *)PRIMUS;
			j->num!=o;
			j=++(*j))
 {
 if(j==NULL)break;
 }
 PUT_BEFORE_NEXUS((NEXUS *)i,(NEXUS *)j);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void numberlist::add_after_number(unsigned int n,unsigned int o)
{
 number *i,*j;
 i=new number(n);
 for(j=(number *)PRIMUS;
			j->num!=o;
			j=++(*j))
 {
 if(j==NULL)break;
 }
 PUT_AFTER_NEXUS((NEXUS *)i,(NEXUS *)j);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void numberlist::show()
{
FOR_EACH(pMF(&number::show));
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
numberlist::~numberlist()
{
printf("IN numberlist Destructor\n");
if(name!=NULL)delete name;

number *temp;
temp=(number *)PRIMUS;
//current must be a number for a nexus
//will only call the nexus destructor
//a number will call the appropriate number
//destructor     May 12 1998 ah finally
//update May 31 2002  fixed the erors by setting a temp variable
//instead of using current

if((PRIMUS!=NULL)&&(MAXIMUS!=NULL))//if not emptty
 for(number *current=(number *)PRIMUS;		 //start on PRIMUS
	  current!=NULL;                 //Stop after Maximus
                       )          //increment current
{
current=(number *)current->next;
     delete temp;
printf("deleted temp");
     temp=current;
}
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
int main()
{
numberlist *nl,*nl2;
number *x;
unsigned long memleft;
//printf("About to spawn command.com and run a DOS command\n");
//	system("ls");
printf("start\n");
//cout<<"\n"<<"CORELEFT BEFORE NEW ="<<coreleft()<<"\n";
//nl2=new numberlist("List with one NEXUS");
nl=new numberlist("List with 4 NEXUS");
//cout<<"\n"<<"CORELEFT AFTER NEW ="<<memleft<<"\n";
nl->add_number(1);
nl->add_number(3);
nl->add_number(5);
nl->add_number(6);
//nl2->add_number(8);
printf("before add_number_primus\n");
//nl2->show();
nl->show();
nl->add_number(2);
nl->add_number(4);
nl->add_number(7);
printf("after add_number_primus\n");
//nl2->XFER(nl2->MAXIMUS,nl);
//nl2->show();
//nl->show();
//cout<<"RESPONDING";
/*/
for(x = (number *)nl->PRIMUS;
	 x != NULL;
	 x =(number *)x->next)
	{
	 x->nc->EXIMO(x->i2);
	 x->nc->EXPERGO(x->i2);  \
	 cout<<"x "<<x->num<<"\n";
	 x->nc->Traverse(x);
	};
/*/
for(x = (number *)nl->PRIMUS;
	 x != NULL;
	 x = ++(*x)) x->nc->Reflex(x);
nl->show();
//cout<<"\n"<<"CORELEFT AFTER NEW ="<<farcoreleft()<<"\n";
if(nl!=NULL)delete nl;
printf("end");
//if(nl2!=NULL)delete nl2;
//cout<<"\n"<<"CORELEFT AFTER DELETE ="<< farcoreleft()<<"\n";
printf("done");
	return 0;
}
////////////////////////////////////////////////////////////////////////////